package com.persagy.dmp.alarm.client;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.PagedResponse;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.cloud.openfeign.FeignClient;


/**
 * @description: 对接物理世界接口
 * @author: lixing
 * @company: Persagy Technology Co.,Ltd
 * @since: 2020/10/20 5:04 下午
 * @version: V1.0
 **/
@FeignClient(name = "dmp-rwd", fallback = PhysicalWorldFallBackFactory.class)
public interface PhysicalWorldClient {

    @PostMapping("rwd/instance/object/query")
    public PagedResponse<ObjectNode> queryObj(
            @RequestParam("projectId") String projectId,
            @RequestParam("groupCode") String groupCode,
            @RequestBody JacksonCriteria criteria);
}
