package com.persagy.dmp.alarm.client;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.PagedResponse;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * @description:
 * @author: lixing
 * @company: Persagy Technology Co.,Ltd
 * @since: 2020/10/26 2:04 下午
 * @version: V1.0
 **/
@Slf4j
@Component
public class PhysicalWorldFallBackFactory implements FallbackFactory<PhysicalWorldClient> {

    @Override
    public PhysicalWorldClient create(Throwable throwable) {
        return new PhysicalWorldClient() {
            @Override
            public PagedResponse<ObjectNode> queryObj(String projectId, String groupCode, JacksonCriteria criteria) {
                // todo 抛出异常统一处理
                log.error("物理世界接口请求失败，url: {}, projectId: {}, requestBody: {}",
                        "/instance/object/query", projectId, criteria);
                return null;
            }
        };
    }
}
