package com.persagy.dmp.alarm.config;

import com.persagy.common.web.MapResponse;
import lombok.extern.slf4j.Slf4j;
import org.springframework.core.Ordered;
import org.springframework.core.annotation.Order;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @description: 全局异常处理
 * @author: lixing
 * @company: Persagy Technology Co.,Ltd
 * @since: 2020/12/4 11:00 上午
 * @version: V1.0
 **/
@RestControllerAdvice
@Slf4j
@Order(Ordered.HIGHEST_PRECEDENCE)
public class GlobalExceptionHandler {
    @ExceptionHandler(value = Exception.class)
    MapResponse handleException(Exception e, HttpServletRequest request, HttpServletResponse response) {
        log.error(e.getMessage());
        MapResponse resp = new MapResponse();
        resp.setResult("fail");
        resp.setMessage(e.getMessage());
        return resp;
    }
}
