package com.persagy.dmp.alarm.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.alarm.model.AlarmLogModel;
import com.persagy.dmp.alarm.service.AlarmLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

@RestController
@RequestMapping("/alarm/log")
public class AlarmLogController {
	@Autowired
	private AlarmLogService service;
	
	@PostMapping("/query")
	public PagedResponse<AlarmLogModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody AlarmLogModel param){
		return service.create(param);
	}
	
//	@PostMapping("/update")
//	public MapResponse update(@RequestBody AlarmLogModel param){
//		return service.update(param);
//	}
//
//	@PostMapping("/delete")
//	public MapResponse delete(@RequestBody AlarmLogModel param){
//		return service.delete(param);
//	}
	
}
