package com.persagy.dmp.alarm.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.alarm.model.AlarmTargetModel;
import com.persagy.dmp.alarm.service.AlarmTargetService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
@RestController
@RequestMapping("/alarm/target")
public class AlarmTargetController {
	@Autowired
	private AlarmTargetService service;
	
	@PostMapping("/query")
	public PagedResponse<AlarmTargetModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody AlarmTargetModel param){
		return service.create(param);
	}
	
	@PostMapping("/update")
	public MapResponse update(@RequestBody AlarmTargetModel param){
		return service.update(param);
	}
	
	@PostMapping("/delete")
	public MapResponse delete(@RequestBody AlarmTargetModel param){
		return service.delete(param);
	}
}
