package com.persagy.dmp.alarm.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.alarm.model.AlarmCommentModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "alarm_comment")
public class AlarmComment {

	@Id
	@GeneratedValue(generator = "assignedId")
	@GenericGenerator(name = "assignedId", strategy = "assigned")
	private String id;
	private String recordId;
	private String content;
	private String createUser;
	private Date createTime;
//	private Date updateTime;
//	private String updateUser;
//	private Integer valid;
	private String projectId;
	private String groupCode;

	public static AlarmComment fromModel(AlarmCommentModel model) {
		AlarmComment entity = new AlarmComment();
		entity.setId(model.getId());
		entity.setRecordId(model.getRecordId());
		entity.setContent(model.getContent());
		entity.setCreateUser(model.getCreateUser());
		entity.setCreateTime(model.getCreateTime());
//		entity.setUpdateTime(model.getUpdateTime());
//		entity.setUpdateUser(model.getUpdateUser());
//		entity.setValid(model.getValid());
		entity.setProjectId(model.getProjectId());
		entity.setGroupCode(model.getGroupCode());
		return entity;
	}

	public AlarmCommentModel toModel() {
		AlarmCommentModel model = new AlarmCommentModel();
		model.setId(this.id);
		model.setRecordId(this.getRecordId());
		model.setContent(this.getContent());
		model.setCreateUser(this.getCreateUser());
		model.setCreateTime(this.getCreateTime());
//		model.setUpdateTime(this.getUpdateTime());
//		model.setUpdateUser(this.getUpdateUser());
//		model.setValid(this.getValid());
		model.setProjectId(this.getProjectId());
		model.setGroupCode(this.getGroupCode());
		return model;
	}

}
