package com.persagy.dmp.alarm.enumeration;

import lombok.Getter;

/**
 * @description: 报警消息类型
 * @author: lixing
 * @company: Persagy Technology Co.,Ltd
 * @since: 2020/10/22 8:08 下午
 * @version: V1.0
 **/
public enum EnumAlarmMessageType {
    ALARM_CONFIGS_CHANGE("alarmConfigsChange", "报警定义变动"),
    ALARM_TARGET_UPDATE("alarmTargetUpdate", "报警匹配条件更新"),
    ALARM_TARGET_CREATE("alarmTargetCreate", "新增报警匹配条件"),
    ALARM_ITEM_CREATE("alarmItemCreate", "新增报警条目"),
    ALARM_ITEM_UPDATE("alarmItemUpdate", "报警条目更新"),
    ALARM_ITEM_DELETE("alarmItemDelete", "删除报警条目"),
    ALARM_RECORD_CREATE("alarmRecordCreate", "新增报警"),
    ALARM_RECORD_UPDATE("alarmRecordUpdate", "报警更新");

    @Getter
    private String value;
    @Getter
    private String desc;

    EnumAlarmMessageType(String value, String desc) {
        this.value = value;
        this.desc = desc;
    }
}
