package com.persagy.dmp.alarm.service;

import com.persagy.common.web.BaseResponse;
import com.persagy.dmp.config.DmpParameterStorage;

/**
 * @author king
 */
public class AlarmBaseService {

	protected static class AlarmParam {
		String groupCode;
		String userId;
		String projectId;
		String appId;
	}

	protected <T> AlarmParam prepareParam(BaseResponse<T> resp) {
		AlarmParam param = new AlarmParam();
		param.groupCode = DmpParameterStorage.getGroupCode();
		param.userId = DmpParameterStorage.getUserId();
		param.projectId = DmpParameterStorage.getProjectId();
		param.appId = DmpParameterStorage.getAppId();
		if (param.userId == null || param.userId.isEmpty()) {
			resp.setResult("fail");
			resp.setMessage("userId 必须有值");
			return null;
		}
		if (param.groupCode == null || param.groupCode.isEmpty()){
			resp.setResult("fail");
			resp.setMessage("groupCode 必须有值");
			return null;
		}
		if (param.projectId == null || param.projectId.isEmpty()){
			resp.setResult("fail");
			resp.setMessage("projectId 必须有值");
			return null;
		}
//		if (param.appId == null || param.appId.isEmpty()){
//			resp.setResult("fail");
//			resp.setMessage("appId 必须有值");
//			return null;
//		}

		return param;
	}

}
