package com.persagy.dmp.common;

import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.BeanFactoryPostProcessor;
import org.springframework.beans.factory.config.ConfigurableListableBeanFactory;

/**
 * @author: yaoll
 * @date: 2020-10-22
 * @verison: 1.0
 */
public class SpringUtils implements BeanFactoryPostProcessor {

	private static ConfigurableListableBeanFactory beanFactory;

	@Override
	public void postProcessBeanFactory(ConfigurableListableBeanFactory beanFactory) throws BeansException {
		SpringUtils.beanFactory = beanFactory;
	}

	public static <T> T getBean(Class<T> aClass) {
		return beanFactory.getBean(aClass);
	}

	public static <T> T getBean(String beanName, Class<T> aClass) {
		return beanFactory.getBean(beanName, aClass);
	}
}
