package com.persagy.dmp.dic.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.dic.model.DtDataModel;
import com.persagy.dmp.dic.model.DtTypeModel;
import com.persagy.dmp.dic.service.DtDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/dic/dt/data")
public class DtDataController {

	@Autowired
	private DtDataService service;
	
	@PostMapping("/query")
	public PagedResponse<DtDataModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody DtDataModel param){
		return service.create(param);
	}
	
	@PostMapping("/update")
	public MapResponse update(@RequestBody DtDataModel param){
		return service.update(param);
	}
	
	@PostMapping("/delete")
	public MapResponse delete(@RequestBody DtDataModel param){
		return service.delete(param);
	}

	@PostMapping("/result")
	public PagedResponse<DtDataModel> query(@RequestBody DtTypeModel dtTypeModel) {
		PagedResponse<DtDataModel> dtDataModelPagedResponse = service.queryData(dtTypeModel);
		return dtDataModelPagedResponse;
	}

}
