package com.persagy.dmp.dic.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.dic.model.DtDataMapModel;
import com.persagy.dmp.dic.service.DtDataMapService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author king
 */
@RestController
@RequestMapping("/dic/dt/data/map")
public class DtDataMapController {
	@Autowired
	private DtDataMapService service;
	
	@PostMapping("/query")
	public PagedResponse<DtDataMapModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody DtDataMapModel param){
		return service.create(param);
	}
	
	@PostMapping("/update")
	public MapResponse update(@RequestBody DtDataMapModel param){
		return service.update(param);
	}
	
	@PostMapping("/delete")
	public MapResponse delete(@RequestBody DtDataMapModel param){
		return service.delete(param);
	}

}
