package com.persagy.dmp.dic.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.dic.model.KlDataModel;
import com.persagy.dmp.dic.service.KlDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
@RestController
@RequestMapping("/dic/kl/data")
public class KlDataController {
	@Autowired
	private KlDataService service;
	
	@PostMapping("/query")
	public PagedResponse<KlDataModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody KlDataModel param){
		return service.create(param);
	}
	
	@PostMapping("/update")
	public MapResponse update(@RequestBody KlDataModel param){
		return service.update(param);
	}
	
	@PostMapping("/delete")
	public MapResponse delete(@RequestBody KlDataModel param){
		return service.delete(param);
	}
	
}
