package com.persagy.dmp.dic.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.dic.model.DtDataModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "dic_dt_data")
public class DtData {

	@Id
	@GeneratedValue(generator = "assignedId")
	@GenericGenerator(name = "assignedId", strategy = "assigned")
	private String id;
	private String dictTypeId;
	private String parentId;
	private String type;
	private String code;
	private String label;
	private Integer orderNum;
	private Integer status;
	private Date createTime;
	private String createUser;
	private Date updateTime;
	private String updateUser;
	private String remark;

	public static DtData fromModel(DtDataModel model) {
		DtData entity = new DtData();
		entity.setId(model.getId());
		entity.setDictTypeId(model.getDictTypeId());
		entity.setParentId(model.getParentId());
		entity.setType(model.getType());
		entity.setCode(model.getCode());
		entity.setLabel(model.getLabel());
		entity.setOrderNum(model.getOrderNum());
		entity.setStatus(model.getStatus());
		entity.setCreateTime(model.getCreateTime());
		entity.setCreateUser(model.getCreateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public DtDataModel toModel() {
		DtDataModel model = new DtDataModel();
		model.setId(this.id);
		model.setDictTypeId(this.getDictTypeId());
		model.setParentId(this.getParentId());
		model.setType(this.getType());
		model.setCode(this.getCode());
		model.setLabel(this.getLabel());
		model.setOrderNum(this.getOrderNum());
		model.setStatus(this.getStatus());
		model.setCreateTime(this.getCreateTime());
		model.setCreateUser(this.getCreateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setRemark(this.getRemark());
		return model;
	}

}
