package com.persagy.dmp.dic.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.dic.model.DtDataMapModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "dic_dt_data_map")
public class DtDataMap {

	@Id
	@GeneratedValue(generator = "assignedId")
	@GenericGenerator(name = "assignedId", strategy = "assigned")
	private String id;
	private String dictDataId;
	private String type;
	private String groupCode;
	private String targetCode;
	private String label;
	private String code;
	private Integer orderNum;
	private Integer status;
	private Date createTime;
	private String createUser;
	private Date updateTime;
	private String updateUser;
	private String remark;

	public static DtDataMap fromModel(DtDataMapModel model) {
		DtDataMap entity = new DtDataMap();
		entity.setId(model.getId());
		entity.setDictDataId(model.getDictDataId());
		entity.setType(model.getType());
		entity.setGroupCode(model.getGroupCode());
		entity.setTargetCode(model.getTargetCode());
		entity.setLabel(model.getLabel());
		entity.setCode(model.getCode());
		entity.setOrderNum(model.getOrderNum());
		entity.setStatus(model.getStatus());
		entity.setCreateTime(model.getCreateTime());
		entity.setCreateUser(model.getCreateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public DtDataMapModel toModel() {
		DtDataMapModel model = new DtDataMapModel();
		model.setId(this.id);
		model.setDictDataId(this.getDictDataId());
		model.setType(this.getType());
		model.setGroupCode(this.getGroupCode());
		model.setTargetCode(this.getTargetCode());
		model.setLabel(this.getLabel());
		model.setCode(this.getCode());
		model.setOrderNum(this.getOrderNum());
		model.setStatus(this.getStatus());
		model.setCreateTime(this.getCreateTime());
		model.setCreateUser(this.getCreateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setRemark(this.getRemark());
		return model;
	}

}
