package com.persagy.dmp.dic.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.dic.model.DtTypeModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "dic_dt_type")
public class DtType {

	@Id
	@GeneratedValue(generator = "assignedId")
	@GenericGenerator(name = "assignedId", strategy = "assigned")
	private String id;
	private String groupCode;
	private String type;
	private String name;
	private String description;
	private Integer status;
	private Date createTime;
	private String createUser;
	private Date updateTime;
	private String updateUser;
	private String remark;

	public static DtType fromModel(DtTypeModel model) {
		DtType entity = new DtType();
		entity.setId(model.getId());
		entity.setGroupCode(model.getGroupCode());
		entity.setType(model.getType());
		entity.setName(model.getName());
		entity.setDescription(model.getDescription());
		entity.setStatus(model.getStatus());
		entity.setCreateTime(model.getCreateTime());
		entity.setCreateUser(model.getCreateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public DtTypeModel toModel() {
		DtTypeModel model = new DtTypeModel();
		model.setId(this.id);
		model.setGroupCode(this.getGroupCode());
		model.setType(this.getType());
		model.setName(this.getName());
		model.setDescription(this.getDescription());
		model.setStatus(this.getStatus());
		model.setCreateTime(this.getCreateTime());
		model.setCreateUser(this.getCreateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setRemark(this.getRemark());
		return model;
	}

}
