package com.persagy.dmp.dic.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.dic.model.KlDataModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "dic_kl_data")
public class KlData {

	@Id
	@GeneratedValue(generator = "assignedId")
	@GenericGenerator(name = "assignedId", strategy = "assigned")
	private String id;
	private String klTypeCode;
	private String klTypeName;
	private String parentId;
	private String code;
	private String label;
	private String value;
	private Integer status;
	private Date createTime;
	private String createUser;
	private Date updateTime;
	private String updateUser;
	private String remark;

	public static KlData fromModel(KlDataModel model) {
		KlData entity = new KlData();
		entity.setId(model.getId());
		entity.setKlTypeCode(model.getKlTypeCode());
		entity.setKlTypeName(model.getKlTypeName());
		entity.setParentId(model.getParentId());
		entity.setCode(model.getCode());
		entity.setLabel(model.getLabel());
		entity.setValue(model.getValue());
		entity.setStatus(model.getStatus());
		entity.setCreateTime(model.getCreateTime());
		entity.setCreateUser(model.getCreateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public KlDataModel toModel() {
		KlDataModel model = new KlDataModel();
		model.setId(this.id);
		model.setKlTypeCode(this.getKlTypeCode());
		model.setKlTypeName(this.getKlTypeName());
		model.setParentId(this.getParentId());
		model.setCode(this.getCode());
		model.setLabel(this.getLabel());
		model.setValue(this.getValue());
		model.setStatus(this.getStatus());
		model.setCreateTime(this.getCreateTime());
		model.setCreateUser(this.getCreateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setRemark(this.getRemark());
		return model;
	}

}
