package com.persagy.dmp.dic.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.dic.model.KlTypeModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "dic_kl_type")
public class KlType {

	@Id
	@GeneratedValue(generator = "assignedId")
	@GenericGenerator(name = "assignedId", strategy = "assigned")
	private String id;
	private String code;
	private String name;
	private String description;
	private Integer status;
	private Date createTime;
	private String createUser;
	private Date updateTime;
	private String updateUser;
	private String remark;

	public static KlType fromModel(KlTypeModel model) {
		KlType entity = new KlType();
		entity.setId(model.getId());
		entity.setCode(model.getCode());
		entity.setName(model.getName());
		entity.setDescription(model.getDescription());
		entity.setStatus(model.getStatus());
		entity.setCreateTime(model.getCreateTime());
		entity.setCreateUser(model.getCreateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public KlTypeModel toModel() {
		KlTypeModel model = new KlTypeModel();
		model.setId(this.id);
		model.setCode(this.getCode());
		model.setName(this.getName());
		model.setDescription(this.getDescription());
		model.setStatus(this.getStatus());
		model.setCreateTime(this.getCreateTime());
		model.setCreateUser(this.getCreateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setRemark(this.getRemark());
		return model;
	}

}
