package com.persagy.dmp.dic.service;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.CriteriaUtils;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.dic.entity.KlData;
import com.persagy.dmp.dic.entity.QKlData;
import com.persagy.dmp.dic.model.KlDataModel;
import com.persagy.dmp.dic.repository.KlDataRepository;
import com.querydsl.core.types.dsl.BooleanExpression;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class KlDataService extends DicBaseService {

	@Autowired
	private KlDataRepository klDataRepository;

	@Autowired
	private CriteriaUtils criteriaUtils;

	private List<BooleanExpression> parse(ObjectNode criteria) {
		// TODO
		return null;
	}

	public PagedResponse<KlDataModel> query(JacksonCriteria criteria) {
		PagedResponse<KlData> resp = criteriaUtils.query(QKlData.klData, this::parse, criteria);
		PagedResponse<KlDataModel> result = new PagedResponse<>();
		result.setCount(resp.getCount());
		List<KlData> dataList = resp.getData();
		if (dataList != null && dataList.size() > 0) {
			List<KlDataModel> collect = dataList.stream().map(entity -> {
				KlDataModel model = entity.toModel();
				return model;
			}).collect(Collectors.toList());
			result.setData(collect);
		}
		return result;
	}

	@Transactional
	public MapResponse create(KlDataModel param) {
		MapResponse response = new MapResponse();
		// TODO
		KlData entity = KlData.fromModel(param);
		klDataRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse update(KlDataModel param) {
		MapResponse response = new MapResponse();
		// TODO
		KlData entity = KlData.fromModel(param);
		klDataRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse delete(KlDataModel param) {
		MapResponse response = new MapResponse();
		// TODO
		KlData entity = KlData.fromModel(param);
		entity.setStatus(0);
		klDataRepository.save(entity);
		response.add("id", entity.getId());
//		klDataRepository.deleteById(param.getId());
		return response;
	}
}

