package com.persagy.dmp.dic.service;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.CriteriaUtils;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.dic.entity.KlType;
import com.persagy.dmp.dic.entity.QKlType;
import com.persagy.dmp.dic.model.KlTypeModel;
import com.persagy.dmp.dic.repository.KlTypeRepository;
import com.querydsl.core.types.dsl.BooleanExpression;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class KlTypeService extends DicBaseService {

	@Autowired
	private KlTypeRepository klTypeRepository;

	@Autowired
	private CriteriaUtils criteriaUtils;

	private List<BooleanExpression> parse(ObjectNode criteria) {
		// TODO
		return null;
	}

	public PagedResponse<KlTypeModel> query(JacksonCriteria criteria) {
		PagedResponse<KlType> resp = criteriaUtils.query(QKlType.klType, this::parse, criteria);
		PagedResponse<KlTypeModel> result = new PagedResponse<>();
		result.setCount(resp.getCount());
		List<KlType> dataList = resp.getData();
		if (dataList != null && dataList.size() > 0) {
			List<KlTypeModel> collect = dataList.stream().map(entity -> {
				KlTypeModel model = entity.toModel();
				return model;
			}).collect(Collectors.toList());
			result.setData(collect);
		}
		return result;
	}

	@Transactional
	public MapResponse create(KlTypeModel param) {
		MapResponse response = new MapResponse();
		// TODO
		KlType entity = KlType.fromModel(param);
		klTypeRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse update(KlTypeModel param) {
		MapResponse response = new MapResponse();
		// TODO
		KlType entity = KlType.fromModel(param);
		klTypeRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse delete(KlTypeModel param) {
		MapResponse response = new MapResponse();
		// TODO
		KlType entity = KlType.fromModel(param);
		entity.setStatus(0);
		klTypeRepository.save(entity);
		response.add("id", entity.getId());
//		klTypeRepository.deleteById(param.getId());
		return response;
	}
}

