package com.persagy.dmp.org.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.org.model.CompanyModel;
import com.persagy.dmp.org.service.CompanyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/org/company")
public class CompanyController {
	@Autowired
	private CompanyService service;
	
	@PostMapping("/query")
	public PagedResponse<CompanyModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody List<CompanyModel> param){
		return service.create(param);
	}
	
	@PostMapping("/update")
	public MapResponse update(@RequestBody List<CompanyModel> params){
		return service.update(params);
	}
	
	@PostMapping("/delete")
	public MapResponse delete(@RequestBody List<CompanyModel> params){
		return service.delete(params);
	}
	
}
