package com.persagy.dmp.org.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.org.model.CompanyProjectRelModel;
import com.persagy.dmp.org.service.CompanyProjectRelService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
@RestController
@RequestMapping("/org/company/project/rel")
public class CompanyProjectRelController {
	@Autowired
	private CompanyProjectRelService service;
	
	@PostMapping("/query")
	public PagedResponse<CompanyProjectRelModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody CompanyProjectRelModel param){
		return service.create(param);
	}
	
	@PostMapping("/update")
	public MapResponse update(@RequestBody CompanyProjectRelModel param){
		return service.update(param);
	}
	
	@PostMapping("/delete")
	public MapResponse delete(@RequestBody CompanyProjectRelModel param){
		return service.delete(param);
	}
	
}
