package com.persagy.dmp.org.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.org.model.GroupModel;
import com.persagy.dmp.org.service.GroupService;
import com.persagy.dmp.org.service.InitService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
@RestController
@RequestMapping("/org/group")
public class GroupController {

	@Autowired
	private GroupService service;

	@PostMapping("/query")
	public PagedResponse<GroupModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/admin/create")
	public MapResponse create(@RequestBody GroupModel param){
		MapResponse mapResponse = service.create(param);
		return mapResponse;
	}

//	@PostMapping("/update")
//	public MapResponse update(@RequestBody GroupModel param){
//		return service.update(param);
//	}
//
//	@PostMapping("/delete")
//	public MapResponse delete(@RequestBody GroupModel param){
//		return service.delete(param);
//	}
	
}
