package com.persagy.dmp.org.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.org.model.GroupFunctionRelModel;
import com.persagy.dmp.org.service.GroupFunctionRelService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/org/group/function/rel")
public class GroupFunctionRelController {
	@Autowired
	private GroupFunctionRelService service;
	
	@PostMapping("/query")
	public PagedResponse<GroupFunctionRelModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody List<GroupFunctionRelModel> params){
		return service.create(params);
	}
	
	@PostMapping("/update")
	public MapResponse update(@RequestBody List<GroupFunctionRelModel> params){
		return service.update(params);
	}
	
	@PostMapping("/delete")
	public MapResponse delete(@RequestBody List<GroupFunctionRelModel> params){
		return service.delete(params);
	}
	
}
