package com.persagy.dmp.org.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.org.model.JobModel;
import com.persagy.dmp.org.model.UserModel;
import com.persagy.dmp.org.service.JobService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/org/job")
public class JobController {
	@Autowired
	private JobService service;
	
	@PostMapping("/query")
	public PagedResponse<JobModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody List<JobModel> params){
		return service.create(params);
	}
	
	@PostMapping("/update")
	public MapResponse update(@RequestBody List<JobModel> params){
		return service.update(params);
	}
	
	@PostMapping("/delete")
	public MapResponse delete(@RequestBody List<JobModel> params){
		return service.delete(params);
	}

	@PostMapping("/user")
	public MapResponse updateJobsByUserId(@RequestBody List<UserModel> params){
		return service.updateJobsByUserId(params);
	};
}
