package com.persagy.dmp.org.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.org.model.ApplicationModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "org_application")
public class Application {

	@Id
	private String id;
	private String code;
	private String name;
	private String category;
	private Integer appOrder;
	private String menuIconKey;
	private String iconKey;
	private String description;
	private String objType;
	private Integer status;
	private String createUser;
	private Date createTime;
	private String updateUser;
	private Date updateTime;
	private String remark;

	public static Application fromModel(ApplicationModel model) {
		Application entity = new Application();
		entity.setId(model.getId());
		entity.setCode(model.getCode());
		entity.setName(model.getName());
		entity.setCategory(model.getCategory());
		entity.setAppOrder(model.getAppOrder());
		entity.setMenuIconKey(model.getMenuIconKey());
		entity.setIconKey(model.getIconKey());
		entity.setDescription(model.getDescription());
		entity.setObjType(model.getObjType());
		entity.setStatus(model.getStatus());
		entity.setCreateUser(model.getCreateUser());
		entity.setCreateTime(model.getCreateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public ApplicationModel toModel() {
		ApplicationModel model = new ApplicationModel();
		model.setId(this.id);
		model.setCode(this.getCode());
		model.setName(this.getName());
		model.setCategory(this.getCategory());
		model.setAppOrder(this.getAppOrder());
		model.setMenuIconKey(this.getMenuIconKey());
		model.setIconKey(this.getIconKey());
		model.setDescription(this.getDescription());
		model.setObjType(this.getObjType());
		model.setStatus(this.getStatus());
		model.setCreateUser(this.getCreateUser());
		model.setCreateTime(this.getCreateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setRemark(this.getRemark());
		return model;
	}

}
