package com.persagy.dmp.org.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.org.model.CompanyModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;
import java.util.List;

@Setter
@Getter
@Entity
@IdClass(GroupPK.class)
@Table(name = "org_company")
public class Company {

	@Id
	private String id;
	private String code;
	private String name;
	@Id
	private String groupCode;
	private String parentId;
	private Integer status;
	private String createUser;
	private Date createTime;
	private String updateUser;
	private Date updateTime;
	private String remark;

//	@JoinTable(name = "org_project", joinColumns = {
//			@JoinColumn(name = "org_id", referencedColumnName = "ID")},
//			inverseJoinColumns = {
//					@JoinColumn(name = "project_id", referencedColumnName = "ID")
//			})
//	@ManyToMany
//	private List<Project> projects;

	public static Company fromModel(CompanyModel model) {
		Company entity = new Company();
		entity.setId(model.getId());
		entity.setCode(model.getCode());
		entity.setName(model.getName());
		entity.setGroupCode(model.getGroupCode());
		entity.setParentId(model.getParentId());
		entity.setStatus(model.getStatus());
		entity.setCreateUser(model.getCreateUser());
		entity.setCreateTime(model.getCreateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public CompanyModel toModel() {
		CompanyModel model = new CompanyModel();
		model.setId(this.id);
		model.setCode(this.getCode());
		model.setName(this.getName());
		model.setGroupCode(this.getGroupCode());
		model.setParentId(this.getParentId());
		model.setStatus(this.getStatus());
		model.setCreateUser(this.getCreateUser());
		model.setCreateTime(this.getCreateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setRemark(this.getRemark());
		return model;
	}

}
