package com.persagy.dmp.org.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.org.model.CompanyProjectRelModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@IdClass(GroupPK.class)
@Table(name = "org_company_project_rel")
public class CompanyProjectRel {

	@Id
	private String id;
	@Id
	private String groupCode;
	private String companyId;
	private String projectId;

	public static CompanyProjectRel fromModel(CompanyProjectRelModel model) {
		CompanyProjectRel entity = new CompanyProjectRel();
		entity.setId(model.getId());
		entity.setCompanyId(model.getCompanyId());
		entity.setProjectId(model.getProjectId());
		entity.setGroupCode(model.getGroupCode());
		return entity;
	}

	public CompanyProjectRelModel toModel() {
		CompanyProjectRelModel model = new CompanyProjectRelModel();
		model.setId(this.id);
		model.setCompanyId(this.getCompanyId());
		model.setProjectId(this.getProjectId());
		model.setGroupCode(this.getGroupCode());
		return model;
	}

}
