package com.persagy.dmp.org.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.org.model.DeptModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@IdClass(GroupPK.class)
@Table(name = "org_dept")
public class Dept {

	@Id
	private String id;
	private String deptClassifyCode;
	private String code;
	private String name;
	private String companyId;
	private String parentId;
	@Id
	private String groupCode;
	private String resourceFrom;
	private String manager;
	private Integer status;
	private String createUser;
	private Date createTime;
	private String updateUser;
	private Date updateTime;
	private String remark;

	public static Dept fromModel(DeptModel model) {
		Dept entity = new Dept();
		entity.setId(model.getId());
		entity.setDeptClassifyCode(model.getDeptClassifyCode());
		entity.setCode(model.getCode());
		entity.setName(model.getName());
		entity.setCompanyId(model.getCompanyId());
		entity.setParentId(model.getParentId());
		entity.setGroupCode(model.getGroupCode());
		entity.setResourceFrom(model.getResourceFrom());
		entity.setManager(model.getManager());
		entity.setStatus(model.getStatus());
		entity.setCreateUser(model.getCreateUser());
		entity.setCreateTime(model.getCreateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public DeptModel toModel() {
		DeptModel model = new DeptModel();
		model.setId(this.id);
		model.setDeptClassifyCode(this.getDeptClassifyCode());
		model.setCode(this.getCode());
		model.setName(this.getName());
		model.setCompanyId(this.getCompanyId());
		model.setParentId(this.getParentId());
		model.setGroupCode(this.getGroupCode());
		model.setResourceFrom(this.getResourceFrom());
		model.setManager(this.getManager());
		model.setStatus(this.getStatus());
		model.setCreateUser(this.getCreateUser());
		model.setCreateTime(this.getCreateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setRemark(this.getRemark());
		return model;
	}

}
