package com.persagy.dmp.org.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.org.model.FunctionModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "org_function")
public class Function {

	@Id
	private String id;
	private String code;
	private String name;
	private String type;
	private String parentId;
	private String appId;
	private String functionUrl;
	private String icon;
	private String description;
	private String functionAlias;
	private String objType;
	private Integer funcOrder;
	private Integer status;
	private String createUser;
	private Date createTime;
	private String updateUser;
	private Date updateTime;
	private String remark;

	public static Function fromModel(FunctionModel model) {
		Function entity = new Function();
		entity.setId(model.getId());
		entity.setCode(model.getCode());
		entity.setName(model.getName());
		entity.setType(model.getType());
		entity.setParentId(model.getParentId());
		entity.setAppId(model.getAppId());
		entity.setFunctionUrl(model.getFunctionUrl());
		entity.setIcon(model.getIcon());
		entity.setDescription(model.getDescription());
		entity.setFunctionAlias(model.getFunctionAlias());
		entity.setObjType(model.getObjType());
		entity.setFuncOrder(model.getFuncOrder());
		entity.setStatus(model.getStatus());
		entity.setCreateUser(model.getCreateUser());
		entity.setCreateTime(model.getCreateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public FunctionModel toModel() {
		FunctionModel model = new FunctionModel();
		model.setId(this.id);
		model.setCode(this.getCode());
		model.setName(this.getName());
		model.setType(this.getType());
		model.setParentId(this.getParentId());
		model.setAppId(this.getAppId());
		model.setFunctionUrl(this.getFunctionUrl());
		model.setIcon(this.getIcon());
		model.setDescription(this.getDescription());
		model.setFunctionAlias(this.getFunctionAlias());
		model.setObjType(this.getObjType());
		model.setFuncOrder(this.getFuncOrder());
		model.setStatus(this.getStatus());
		model.setCreateUser(this.getCreateUser());
		model.setCreateTime(this.getCreateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setRemark(this.getRemark());
		return model;
	}

}
