package com.persagy.dmp.org.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.org.model.GroupModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "org_group")
public class Group {

	@Id
	private String id;
	private String code;
	private String name;
	private Integer status;
	private String createUser;
	private Date createTime;
	private String updateUser;
	private Date updateTime;
	private String remark;

	public static Group fromModel(GroupModel model) {
		Group entity = new Group();
		entity.setId(model.getId());
		entity.setCode(model.getCode());
		entity.setName(model.getName());
		entity.setStatus(model.getStatus());
		entity.setCreateUser(model.getCreateUser());
		entity.setCreateTime(model.getCreateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public GroupModel toModel() {
		GroupModel model = new GroupModel();
		model.setId(this.id);
		model.setCode(this.getCode());
		model.setName(this.getName());
		model.setStatus(this.getStatus());
		model.setCreateUser(this.getCreateUser());
		model.setCreateTime(this.getCreateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setRemark(this.getRemark());
		return model;
	}

}
