package com.persagy.dmp.org.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.org.model.GroupAppRelModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@IdClass(GroupPK.class)
@Table(name = "org_group_app_rel")
public class GroupAppRel {

	@Id
	private String id;
	@Id
	private String groupCode;
	private String appId;
	private Integer authorityType;
	private Integer status;
	private String createUser;
	private Date createTime;
	private String updateUser;
	private Date updateTime;
	private String remark;

	public static GroupAppRel fromModel(GroupAppRelModel model) {
		GroupAppRel entity = new GroupAppRel();
		entity.setId(model.getId());
		entity.setGroupCode(model.getGroupCode());
		entity.setAppId(model.getAppId());
		entity.setAuthorityType(model.getAuthorityType());
		entity.setStatus(model.getStatus());
		entity.setCreateUser(model.getCreateUser());
		entity.setCreateTime(model.getCreateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public GroupAppRelModel toModel() {
		GroupAppRelModel model = new GroupAppRelModel();
		model.setId(this.id);
		model.setGroupCode(this.getGroupCode());
		model.setAppId(this.getAppId());
		model.setAuthorityType(this.getAuthorityType());
		model.setStatus(this.getStatus());
		model.setCreateUser(this.getCreateUser());
		model.setCreateTime(this.getCreateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setRemark(this.getRemark());
		return model;
	}

}
