package com.persagy.dmp.org.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.org.model.GroupFunctionRelModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@IdClass(GroupPK.class)
@Table(name = "org_group_function_rel")
public class GroupFunctionRel {

	@Id
	private String id;
	@Id
	private String groupCode;
	private String functionId;
	private String authorityType;
	private Integer status;
	private String createUser;
	private Date createTime;
	private String updateUser;
	private Date updateTime;
	private String remark;

	public static GroupFunctionRel fromModel(GroupFunctionRelModel model) {
		GroupFunctionRel entity = new GroupFunctionRel();
		entity.setId(model.getId());
		entity.setGroupCode(model.getGroupCode());
		entity.setFunctionId(model.getFunctionId());
		entity.setAuthorityType(model.getAuthorityType());
		entity.setStatus(model.getStatus());
		entity.setCreateUser(model.getCreateUser());
		entity.setCreateTime(model.getCreateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public GroupFunctionRelModel toModel() {
		GroupFunctionRelModel model = new GroupFunctionRelModel();
		model.setId(this.id);
		model.setGroupCode(this.getGroupCode());
		model.setFunctionId(this.getFunctionId());
		model.setAuthorityType(this.getAuthorityType());
		model.setStatus(this.getStatus());
		model.setCreateUser(this.getCreateUser());
		model.setCreateTime(this.getCreateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setRemark(this.getRemark());
		return model;
	}

}
