package com.persagy.dmp.org.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.org.model.JobModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@IdClass(GroupPK.class)
@Table(name = "org_job")
public class Job {

	@Id
	private String id;
	private String code;
	private String name;
	@Id
	private String groupCode;
	private String userId;
	private String deptId;
	private String jobClassifyCode;
	private String resourceFrom;
	private Integer status;
	private String createUser;
	private Date createTime;
	private String updateUser;
	private Date updateTime;
	private String remark;

	public static Job fromModel(JobModel model) {
		Job entity = new Job();
		entity.setId(model.getId());
		entity.setCode(model.getCode());
		entity.setName(model.getName());
		entity.setGroupCode(model.getGroupCode());
		entity.setUserId(model.getUserId());
		entity.setDeptId(model.getDeptId());
		entity.setJobClassifyCode(model.getJobClassifyCode());
		entity.setResourceFrom(model.getResourceFrom());
		entity.setStatus(model.getStatus());
		entity.setCreateUser(model.getCreateUser());
		entity.setCreateTime(model.getCreateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public JobModel toModel() {
		JobModel model = new JobModel();
		model.setId(this.id);
		model.setCode(this.getCode());
		model.setName(this.getName());
		model.setGroupCode(this.getGroupCode());
		model.setUserId(this.getUserId());
		model.setDeptId(this.getDeptId());
		model.setJobClassifyCode(this.getJobClassifyCode());
		model.setResourceFrom(this.getResourceFrom());
		model.setStatus(this.getStatus());
		model.setCreateUser(this.getCreateUser());
		model.setCreateTime(this.getCreateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setRemark(this.getRemark());
		return model;
	}

}
