package com.persagy.dmp.org.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.org.model.JobClassifyRelModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@IdClass(GroupPK.class)
@Table(name = "org_job_classify_rel")
public class JobClassifyRel {

	@Id
	private String id;
	private String jobClassifyCode;
	private String appId;
	private String functionId;
	@Id
	private String groupCode;
	private Integer status;
	private String createUser;
	private Date createTime;
	private String updateUser;
	private Date updateTime;
	private String remark;

	public static JobClassifyRel fromModel(JobClassifyRelModel model) {
		JobClassifyRel entity = new JobClassifyRel();
		entity.setId(model.getId());
		entity.setJobClassifyCode(model.getJobClassifyCode());
		entity.setAppId(model.getAppId());
		entity.setFunctionId(model.getFunctionId());
		entity.setGroupCode(model.getGroupCode());
		entity.setStatus(model.getStatus());
		entity.setCreateUser(model.getCreateUser());
		entity.setCreateTime(model.getCreateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public JobClassifyRelModel toModel() {
		JobClassifyRelModel model = new JobClassifyRelModel();
		model.setId(this.id);
		model.setJobClassifyCode(this.getJobClassifyCode());
		model.setAppId(this.getAppId());
		model.setFunctionId(this.getFunctionId());
		model.setGroupCode(this.getGroupCode());
		model.setStatus(this.getStatus());
		model.setCreateUser(this.getCreateUser());
		model.setCreateTime(this.getCreateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setRemark(this.getRemark());
		return model;
	}

}
