package com.persagy.dmp.org.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.org.model.ProjectModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@IdClass(GroupPK.class)
@Table(name = "org_project")
public class Project {

	@Id
	private String id;
	private String name;
	@Id
	private String groupCode;
	private Integer status;
	private String createUser;
	private Date createTime;
	private String updateUser;
	private Date updateTime;
	private String remark;

	public static Project fromModel(ProjectModel model) {
		Project entity = new Project();
		entity.setId(model.getId());
		entity.setName(model.getName());
		entity.setGroupCode(model.getGroupCode());
		entity.setStatus(model.getStatus());
		entity.setCreateUser(model.getCreateUser());
		entity.setCreateTime(model.getCreateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setRemark(model.getRemark());
		return entity;
	}

	public ProjectModel toModel() {
		ProjectModel model = new ProjectModel();
		model.setId(this.id);
		model.setName(this.getName());
		model.setGroupCode(this.getGroupCode());
		model.setStatus(this.getStatus());
		model.setCreateUser(this.getCreateUser());
		model.setCreateTime(this.getCreateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setRemark(this.getRemark());
		return model;
	}

}
