package com.persagy.dmp.org.entity;

import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.org.model.UserModel;
import org.hibernate.annotations.GenericGenerator;
import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@IdClass(GroupPK.class)
@Table(name = "org_user")
public class User {

	@Id
	private String id;
	private String personId;
	private String name;
	private String username;
	private String password;
	private String idNumber;
	private Integer gender;
	private String phone;
	private String mail;
	private Date birthday;
	private String headPortrait;
	private String otherAccount;
	private String userFrom;
	@Id
	private String groupCode;
	private String isAdmin;
	private Integer status;
	private String createUser;
	private Date createTime;
	private String updateUser;
	private Date updateTime;
	private String remark;

	private Date lastLoginTime;
	private String lastIp;

	public static User fromModel(UserModel model) {
		User entity = new User();
		entity.setId(model.getId());
		entity.setPersonId(model.getPersonId());
		entity.setName(model.getName());
		entity.setUsername(model.getUsername());
		entity.setPassword(model.getPassword());
		entity.setIdNumber(model.getIdNumber());
		entity.setGender(model.getGender());
		entity.setPhone(model.getPhone());
		entity.setMail(model.getMail());
		entity.setBirthday(model.getBirthday());
		entity.setHeadPortrait(model.getHeadPortrait());
		entity.setOtherAccount(model.getOtherAccount());
		entity.setUserFrom(model.getUserFrom());
		entity.setGroupCode(model.getGroupCode());
		entity.setIsAdmin(model.getIsAdmin());
		entity.setStatus(model.getStatus());
		entity.setCreateUser(model.getCreateUser());
		entity.setCreateTime(model.getCreateTime());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setRemark(model.getRemark());
		entity.setLastLoginTime(model.getLastLoginTime());
		entity.setLastIp(model.getLastIp());
		return entity;
	}

	public UserModel toModel() {
		UserModel model = new UserModel();
		model.setId(this.id);
		model.setPersonId(this.getPersonId());
		model.setName(this.getName());
		model.setUsername(this.getUsername());
		model.setPassword(this.getPassword());
		model.setIdNumber(this.getIdNumber());
		model.setGender(this.getGender());
		model.setPhone(this.getPhone());
		model.setMail(this.getMail());
		model.setBirthday(this.getBirthday());
		model.setHeadPortrait(this.getHeadPortrait());
		model.setOtherAccount(this.getOtherAccount());
		model.setUserFrom(this.getUserFrom());
		model.setGroupCode(this.getGroupCode());
		model.setIsAdmin(this.getIsAdmin());
		model.setStatus(this.getStatus());
		model.setCreateUser(this.getCreateUser());
		model.setCreateTime(this.getCreateTime());
		model.setUpdateUser(this.getUpdateUser());
		model.setUpdateTime(this.getUpdateTime());
		model.setRemark(this.getRemark());
		model.setLastLoginTime(this.getLastLoginTime());
		model.setLastIp(this.getLastIp());
		return model;
	}

}
