package com.persagy.dmp.org.service;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.querydsl.core.types.dsl.BooleanExpression;
import com.persagy.common.criteria.CriteriaUtils;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.PagedResponse;
import com.persagy.common.web.MapResponse;
import javax.transaction.Transactional;
import org.springframework.stereotype.Service;
import java.util.stream.Collectors;
import com.persagy.dmp.org.model.CompanyProjectRelModel;
import org.springframework.beans.factory.annotation.Autowired;
import com.persagy.dmp.org.entity.*;
import com.persagy.dmp.org.repository.CompanyProjectRelRepository;

import java.util.Date;
import java.util.LinkedList;
import java.util.List;
import java.util.Optional;

@Service
public class CompanyProjectRelService {

	@Autowired
	private CompanyProjectRelRepository companyProjectRelRepository;

	@Autowired
	private CriteriaUtils criteriaUtils;

	private List<BooleanExpression> parse(ObjectNode criteria) {
		// TODO
		return null;
	}

	public PagedResponse<CompanyProjectRelModel> query(JacksonCriteria criteria) {
		PagedResponse<CompanyProjectRel> resp = criteriaUtils.query(QCompanyProjectRel.companyProjectRel, this::parse, criteria);
		PagedResponse<CompanyProjectRelModel> result = new PagedResponse<>();
		result.setCount(resp.getCount());
		List<CompanyProjectRel> dataList = resp.getData();
		if (dataList != null && dataList.size() > 0) {
			List<CompanyProjectRelModel> collect = dataList.stream().map(entity -> {
				CompanyProjectRelModel model = entity.toModel();
				return model;
			}).collect(Collectors.toList());
			result.setData(collect);
		}
		return result;
	}

	@Transactional
	public MapResponse create(CompanyProjectRelModel param) {
		MapResponse response = new MapResponse();
		// TODO
		CompanyProjectRel entity = CompanyProjectRel.fromModel(param);
		companyProjectRelRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse update(CompanyProjectRelModel param) {
		MapResponse response = new MapResponse();
		// TODO
		CompanyProjectRel entity = CompanyProjectRel.fromModel(param);
		companyProjectRelRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse delete(CompanyProjectRelModel param) {
		MapResponse response = new MapResponse();
		// TODO
		CompanyProjectRel entity = CompanyProjectRel.fromModel(param);
		companyProjectRelRepository.delete(entity);
		return response;
	}
}

