package com.persagy.dmp.rwd.datautils;

import com.persagy.common.json.JacksonMapper;
import com.persagy.dmp.common.http.HttpUtils;
import com.persagy.dmp.rwd.funcid.parse.parser.InfoCodeParserFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.core.env.ConfigurableEnvironment;

/**
 * @author: yaoll
 * @date: 2020-10-14
 * @verison: 1.0
 */
@Slf4j
@SpringBootApplication
public class TransApp {

	public static void main(String[] args) {

		log.info("======================= app start");
		ConfigurableApplicationContext context = SpringApplication.run(TransApp.class, args);
		ConfigurableEnvironment env = context.getEnvironment();

		String[] activeProfiles = env.getActiveProfiles();
		log.info("======================= active profile: {}", JacksonMapper.toSimpleJson(activeProfiles));
		try {
			Thread.sleep(3000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		log.info("======================= app end");

	}

	@Bean
	public HttpUtils httpUtils() {
		return new HttpUtils();
	}

	@Bean
	public InfoCodeParserFactory infoCodeParserFactory(){
		return new InfoCodeParserFactory();
	}
}
