package com.persagy.dmp.rwd.datautils.config;

import lombok.Getter;
import lombok.Setter;

import java.util.LinkedList;
import java.util.List;

/**
 * @author: yaoll
 * @date: 2020-12-01
 * @verison: 1.0
 */
public class GraphMapping {

	private static final List<Item> mappings = new LinkedList<>();

	static {
		mappings.add(new Item("ArchSubset", "Bd2Fl", "Subset", "1", "1"));
		mappings.add(new Item("ArchSubset", "Bd2Sh", "ShaftandBuilding", "1", "1"));
		mappings.add(new Item("ArchSubset", "Bd2Sp", "Subset", "2", "1"));
		mappings.add(new Item("ArchSubset", "Fl2Sp", "Subset", "4", "1"));
		mappings.add(new Item("ArchSubset", "Sh2Sp", "ShaftandSpace", "1", "1"));
		mappings.add(new Item("MechSubset", "Sy2Eq", "SystemEquip", "1", "1"));
		mappings.add(new Item("MechSubset", "Eq2Ec", "Subset", "5", "1"));
		mappings.add(new Item("SpaceNeighborhood", "None", "SpaceNeighborhood", "1", "1"));
		mappings.add(new Item("SpaceNeighborhood", "Door", "SpaceNeighborhood", "2", "1"));
		mappings.add(new Item("SpaceNeighborhood", "Window", "SpaceNeighborhood", "3", "1"));
		mappings.add(new Item("SpaceNeighborhood", "DoorWindow", "SpaceNeighborhood", "4", "1"));
		mappings.add(new Item("SpaceNeighborhood", "Connect", "SpaceNeighborhood", "5", "1"));
		mappings.add(new Item("TrafficNetwork", "Normal", "TrafficNetwork", "1", "1"));
		mappings.add(new Item("TrafficNetwork", "FFOpen", "TrafficNetwork", "2", "1"));
		mappings.add(new Item("TrafficNetwork", "FFClose", "TrafficNetwork", "3", "1"));
		mappings.add(new Item("ConvectionNetwork", "Natural", "ConvectionNetwork", "1", "1"));
		mappings.add(new Item("ConvectionNetwork", "MixMech", "ConvectionNetwork", "2", "1"));
		mappings.add(new Item("RadiationNetwork", "Connect", "RadiationNetwork", "1", "1"));
		mappings.add(new Item("RadiationNetwork", "Transparent", "RadiationNetwork", "2", "1"));
		mappings.add(new Item("LUDistribution", "Normal", "LUDistribution", "1", "1"));
		mappings.add(new Item("LUDistribution", "Backup", "LUDistribution", "2", "1"));
		mappings.add(new Item("HUDistribution", "Normal", "HUDistribution", "1", "1"));
		mappings.add(new Item("HUDistribution", "Backup", "HUDistribution", "2", "1"));
		mappings.add(new Item("ChillWaterLoop", "Supply", "ChillWaterLoop", "1", "1"));
		mappings.add(new Item("ChillWaterLoop", "Return", "ChillWaterLoop", "2", "1"));
		mappings.add(new Item("ChillWaterLoop", "Bypass", "ChillWaterLoop", "3", "1"));
		mappings.add(new Item("ChillWaterLoop", "Fill", "ChillWaterLoop", "4", "1"));
		mappings.add(new Item("CoolingWaterLoop", "Supply", "CoolingWaterLoop", "1", "1"));
		mappings.add(new Item("CoolingWaterLoop", "Return", "CoolingWaterLoop", "2", "1"));
		mappings.add(new Item("CoolingWaterLoop", "Bypass", "CoolingWaterLoop", "3", "1"));
		mappings.add(new Item("CoolingWaterLoop", "Fill", "CoolingWaterLoop", "4", "1"));
		mappings.add(new Item("HeatWaterLoop", "Supply", "HeatWaterLoop", "1", "1"));
		mappings.add(new Item("HeatWaterLoop", "Return", "HeatWaterLoop", "2", "1"));
		mappings.add(new Item("HeatWaterLoop", "Bypass", "HeatWaterLoop", "3", "1"));
		mappings.add(new Item("HeatWaterLoop", "Fill", "HeatWaterLoop", "4", "1"));
		mappings.add(new Item("CondWaterNetwork", "Discharge", "CondWaterNetwork", "1", "1"));
		mappings.add(new Item("ACAirNetwork", "Supply", "ACAirNetwork", "1", "1"));
		mappings.add(new Item("ACAirNetwork", "Return", "ACAirNetwork", "2", "1"));
		mappings.add(new Item("FreshAirNetwork", "Fresh", "FreshAirNetwork", "1", "1"));
		mappings.add(new Item("VentNetwork", "Supply", "VentNetwork", "1", "1"));
		mappings.add(new Item("VentNetwork", "Discharge", "VentNetwork", "2", "1"));
		mappings.add(new Item("VentNetwork", "Uncertain", "VentNetwork", "3", "1"));
		mappings.add(new Item("VRFNetwork", "SupplyReturn", "VRFNetwork", "1", "1"));
		mappings.add(new Item("DomesticWaterNetwork", "Supply", "SupplyWaterNetwork", "1", "1"));
		mappings.add(new Item("DomesticWaterNetwork", "Bypass", "SupplyWaterNetwork", "2", "1"));
		mappings.add(new Item("DrainingWaterNetwork", "Discharge", "DrainingWaterNetwork", "1", "1"));
		mappings.add(new Item("DrainingWaterNetwork", "Bypass", "DrainingWaterNetwork", "2", "1"));
		mappings.add(new Item("RecycleWaterNetwork", "Supply", "RecycleWaterNetwork", "1", "1"));
		mappings.add(new Item("RecycleWaterNetwork", "Bypass", "RecycleWaterNetwork", "2", "1"));
		mappings.add(new Item("DrinkingWaterNetwork", "Supply", "DrinkingWaterNetwork", "1", "1"));
		mappings.add(new Item("DrinkingWaterNetwork", "Bypass", "DrinkingWaterNetwork", "2", "1"));
		mappings.add(new Item("DHWNetwork", "Supply", "DHWNetwork", "1", "1"));
		mappings.add(new Item("DHWNetwork", "Bypass", "DHWNetwork", "2", "1"));
		mappings.add(new Item("GasNetwork", "Supply", "GasNetwork", "1", "1"));
		mappings.add(new Item("GasNetwork", "Bypass", "GasNetwork", "2", "1"));
		mappings.add(new Item("FireWaterNetwork", "Supply", "FireWaterNetwork", "1", "1"));
		mappings.add(new Item("FireWaterNetwork", "Bypass", "FireWaterNetwork", "2", "1"));
		mappings.add(new Item("FireVentNetwork", "Discharge", "FireVentNetwork", "1", "1"));
		mappings.add(new Item("WENetwork", "Normal", "SensorNetwork", "1", "1"));
		mappings.add(new Item("MechInArch", "Eq2Bd", "Subset", "3", "0"));
		mappings.add(new Item("MechInArch", "Eq2Fl", "EquipinFloor", "1", "1"));
		mappings.add(new Item("MechInArch", "Eq2Sp", "EquipinSpace", "1", "1"));
		mappings.add(new Item("MechCtrl", "EqCtrl", "ControlRelation", "1", "1"));
		mappings.add(new Item("MechPower", "EqNormal", "EquipPower", "1", "1"));
		mappings.add(new Item("MechPower", "EqBackup", "EquipPower", "2", "1"));
		mappings.add(new Item("MechForArch", "Eq2Sp", "EquipforSpace", "1", "1"));
		mappings.add(new Item("Property2Mech", "Pe2Eq", "Pe2Eq", "1", "1"));
		mappings.add(new Item("PropertyInArch", "Pe2Bd", "Subset", "6", "0"));
		mappings.add(new Item("PropertyInArch", "Pe2Fl", "Subset", "7", "0"));
		mappings.add(new Item("SubE", "Sub2Sub", "SubE", "1", "1"));
		mappings.add(new Item("SubE", "Mt2Sub", "SubE", "2", "1"));
		mappings.add(new Item("SubE", "Br2Sub", "SubE", "3", "1"));
		mappings.add(new Item("SubE", "Un2Sub", "SubE", "4", "1"));
		mappings.add(new Item("SubC", "Sub2Sub", "SubC", "1", "1"));
		mappings.add(new Item("SubC", "Mt2Sub", "SubC", "2", "1"));
		mappings.add(new Item("SubC", "Br2Sub", "SubC", "3", "1"));
		mappings.add(new Item("SubC", "Un2Sub", "SubC", "4", "1"));
		mappings.add(new Item("SubH", "Sub2Sub", "SubH", "1", "1"));
		mappings.add(new Item("SubH", "Mt2Sub", "SubH", "2", "1"));
		mappings.add(new Item("SubH", "Br2Sub", "SubH", "3", "1"));
		mappings.add(new Item("SubH", "Un2Sub", "SubH", "4", "1"));
		mappings.add(new Item("SubW", "Sub2Sub", "SubW", "1", "1"));
		mappings.add(new Item("SubW", "Mt2Sub", "SubW", "2", "1"));
		mappings.add(new Item("SubW", "Br2Sub", "SubW", "3", "1"));
		mappings.add(new Item("SubW", "Un2Sub", "SubW", "4", "1"));
		mappings.add(new Item("SubG", "Sub2Sub", "SubG", "1", "1"));
		mappings.add(new Item("SubG", "Mt2Sub", "SubG", "2", "1"));
		mappings.add(new Item("SubG", "Br2Sub", "SubG", "3", "1"));
		mappings.add(new Item("SubG", "Un2Sub", "SubG", "4", "1"));
		mappings.add(new Item("SubF", "Sub2Sub", "SubF", "1", "1"));
		mappings.add(new Item("SubF", "Mt2Sub", "SubF", "2", "1"));
		mappings.add(new Item("SubF", "Br2Sub", "SubF", "3", "1"));
		mappings.add(new Item("SubF", "Un2Sub", "SubF", "4", "1"));
		mappings.add(new Item("SubV", "Sub2Sub", "SubV", "1", "1"));
		mappings.add(new Item("SubV", "Mt2Sub", "SubV", "2", "1"));
		mappings.add(new Item("SubV", "Br2Sub", "SubV", "3", "1"));
		mappings.add(new Item("SubV", "Un2Sub", "SubV", "4", "1"));
		mappings.add(new Item("EnergyMonitorStructure", "Mt2Br", "EnergyMonitorStructure", "2", "1"));
		mappings.add(new Item("EnergyMonitorStructure", "Mt2Un", "EnergyMonitorStructure", "3", "1"));
		mappings.add(new Item("EnergyMonitorStructure", "Br2Un", "EnergyMonitorStructure", "4", "1"));
		mappings.add(new Item("VRFNetwork", "SupplyReturn", "VRFNetwork", "2", "0"));
		mappings.add(new Item("WENetwork", "Normal", "ControlEquipNetwork", "1", "1"));
		mappings.add(new Item("PropertyInArch", "Pe2Bd", "Pe2Bd", "1", "1"));
		mappings.add(new Item("PropertyInArch", "Pe2Fl", "Pe2Fl", "1", "1"));
		mappings.add(new Item("SubE", "Sub2Sub", "EnergyItemTree", "1", "1"));
		mappings.add(new Item("EnergyMonitorStructure", "Mt2Br", "EnergyMonitorStructure", "1", "1"));
	}

	public static Item getMapping(String graph, String relCode) {
		for (Item mapping : mappings) {
			if (mapping.oldGraph.equals(graph) && mapping.oldRelcode.equals(relCode)) {
				return mapping;
			}
		}
		return null;
	}

	@Getter
	@Setter
	public static class Item {
		private String newGraph;
		private String newRelcode;
		private String oldGraph;
		private String oldRelcode;
		private Boolean same;

		public Item(String newGraph, String newRelcode, String oldGraph, String oldRelcode, String same) {
			this.newGraph = newGraph;
			this.newRelcode = newRelcode;
			this.oldGraph = oldGraph;
			this.oldRelcode = oldRelcode;
			this.same = "1".equalsIgnoreCase(same);
		}
	}


}
