package com.persagy.dmp.rwd.datautils.model;

import com.persagy.common.date.DateUtils;
import lombok.Data;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @author: yaoll
 * @date: 2020-10-14
 * @verison: 1.0
 */
@Data
public class TransContext {

	private String basePath;

	private String dataFile;

	private String groupCode;

	private String schemaId;

	private String projectId;

	private String appId = "datautils";

	private Map<String, String> classCodeMapping = new HashMap<>();

	private Map<String, String> objTypeMapping = new HashMap<>();

	public String getErrorFile() {
		int idx = this.dataFile.lastIndexOf(".");
		return this.dataFile.substring(0, idx) + "-error-" + DateUtils.format(new Date()) + ".json";
	}

	public String getOutFile() {
		int idx = this.dataFile.lastIndexOf(".");
		return this.dataFile.substring(0, idx) + "-out-" + DateUtils.format(new Date()) + ".json";
	}
}
