package com.persagy.dmp.rwd.knowladge;

import com.persagy.common.json.JacksonMapper;
import com.persagy.dmp.rwd.dic.ExcelUtils;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.junit.Test;

import java.io.FileInputStream;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

/**
 * @author: yaoll
 * @date: 2020-12-02
 * @verison: 1.0
 */
@Slf4j
public class Test1 {

	private String basepath = "/Users/devsaga/persagy/数据字典20201118/Ch4-专家知识库";

	@Data
	public static class Item {
		private String code;
		private String name;
		private String parentCode;

		public Item(String code, String name, String parentCode) {
			this.code = code;
			this.name = name;
			this.parentCode = parentCode;
		}
	}

	@Test
	public void test1() throws Exception {
		String file = basepath + "/4.2-行业推荐模型/4.2.1-推荐空间业态分类.xlsx";
		String sheetname = "3空间功能类型";

		FileInputStream inputStream = new FileInputStream(file);
		Workbook workbook = new XSSFWorkbook(inputStream);
		Sheet sheet = workbook.getSheet(sheetname);

		// 行号从0开始, 从第3行开始读数据
		int startRowNum = 3;
		int lastRowNum = sheet.getLastRowNum();

		List<FuncType> list = new LinkedList<>();
		FuncType temp = new FuncType();
		for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
			Row row = sheet.getRow(rowIndex);
			if (row == null) {
				continue;
			}
			FuncType target = new FuncType();
			int i = 3;
			target.c = (String) ExcelUtils.parseCell(row.getCell(i++), "string");
			target.d = (String) ExcelUtils.parseCell(row.getCell(i++), "string");
			if (target.c == null) {
				target.c = temp.c;
				target.d = temp.d;
			} else {
				temp.c = target.c;
				temp.d = target.d;
				temp.e = null;
				temp.f = null;
				temp.g = null;
				temp.h = null;
				temp.i = null;
				temp.j = null;
			}

			target.e = (String) ExcelUtils.parseCell(row.getCell(i++), "string");
			target.f = (String) ExcelUtils.parseCell(row.getCell(i++), "string");
			if (target.e == null) {
				target.e = temp.e;
				target.f = temp.f;
			} else {
				temp.e = target.e;
				temp.f = target.f;
				temp.g = null;
				temp.h = null;
				temp.i = null;
				temp.j = null;
			}

			target.g = (String) ExcelUtils.parseCell(row.getCell(i++), "string");
			target.h = (String) ExcelUtils.parseCell(row.getCell(i++), "string");
			if (target.g == null) {
				target.g = temp.g;
				target.h = temp.h;
			} else {
				temp.g = target.g;
				temp.h = target.h;
				temp.i = null;
				temp.j = null;
			}

			target.i = (String) ExcelUtils.parseCell(row.getCell(i++), "string");
			target.j = (String) ExcelUtils.parseCell(row.getCell(i++), "string");
			list.add(target);
		}

		List<Item> data = new LinkedList<>();
		Set<String> codes = new HashSet<>();
		for (FuncType t : list) {
			if (t.d != null && !codes.contains(t.d)) {
				data.add(new Item(t.d, t.c, null));
				codes.add(t.d);
			}
		}
		for (FuncType t : list) {
			if (t.f != null && !codes.contains(t.f)) {
				data.add(new Item(t.f, t.e, t.d));
				codes.add(t.f);
			}
		}
		for (FuncType t : list) {
			if (t.h != null && !codes.contains(t.h)) {
				data.add(new Item(t.h, t.g, t.f));
				codes.add(t.h);
			}
		}
		for (FuncType t : list) {
			if (t.j != null && !codes.contains(t.j)) {
				data.add(new Item(t.j, t.i, t.h));
				codes.add(t.j);
			}
		}
		for (Item item : data) {
//			System.out.println(item.code + "\t\t" + item.name + "\t\t" + item.parentCode);
			System.out.println(JacksonMapper.toSimpleJson(item));
		}
	}

	@Test
	public void test2() throws Exception {
		String file = basepath + "/4.2-行业推荐模型/4.2.1-推荐空间业态分类.xlsx";
		String sheetname = "4商业租赁业态类型";

		FileInputStream inputStream = new FileInputStream(file);
		Workbook workbook = new XSSFWorkbook(inputStream);
		Sheet sheet = workbook.getSheet(sheetname);

		// 行号从0开始, 从第3行开始读数据
		int startRowNum = 3;
		int lastRowNum = sheet.getLastRowNum();

		List<FuncType> list = new LinkedList<>();
		FuncType temp = new FuncType();
		for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
			Row row = sheet.getRow(rowIndex);
			if (row == null) {
				continue;
			}
			FuncType target = new FuncType();
			int i = 2;
			target.c = (String) ExcelUtils.parseCell(row.getCell(i++), "string");// B
			target.d = (String) ExcelUtils.parseCell(row.getCell(i++), "string");// C
			if (target.c == null) {
				target.c = temp.c;
				target.d = temp.d;
			} else {
				temp.c = target.c;
				temp.d = target.d;
				temp.e = null;
				temp.f = null;
				temp.g = null;
				temp.h = null;
			}

			target.e = (String) ExcelUtils.parseCell(row.getCell(i++), "string");// D
			target.f = (String) ExcelUtils.parseCell(row.getCell(i++), "string");// E
			if (target.e == null) {
				target.e = temp.e;
				target.f = temp.f;
			} else {
				temp.e = target.e;
				temp.f = target.f;
				temp.g = null;
				temp.h = null;
			}

			target.g = (String) ExcelUtils.parseCell(row.getCell(i++), "string");// F
			target.h = (String) ExcelUtils.parseCell(row.getCell(i++), "string");// G
			list.add(target);
		}

		List<Item> data = new LinkedList<>();
		Set<String> codes = new HashSet<>();
		for (FuncType t : list) {
			if (t.d != null && !codes.contains(t.d)) {
				data.add(new Item(t.d, t.c, null));
				codes.add(t.d);
			}
		}
		for (FuncType t : list) {
			if (t.f != null && !codes.contains(t.f)) {
				data.add(new Item(t.f, t.e, t.d));
				codes.add(t.f);
			}
		}
		for (FuncType t : list) {
			if (t.h != null && !codes.contains(t.h)) {
				data.add(new Item(t.h, t.g, t.f));
				codes.add(t.h);
			}
		}

		for (Item item : data) {
//			System.out.println(item.code + "\t\t" + item.name + "\t\t" + item.parentCode);
			System.out.println(JacksonMapper.toSimpleJson(item));
		}
	}

	private String pre(String str){
		if (str == null) {
			return null;
		}
		if (str.indexOf(".") > -1) {
			return str.substring(0, str.indexOf("."));
		} else {
			return str;
		}
	}

	@Test
	public void test3() throws Exception {
		String file = basepath + "/4.1-默认全局属性/4.1.1-地域性信息.xlsx";
		String sheetname = "1省市区编号";

		FileInputStream inputStream = new FileInputStream(file);
		Workbook workbook = new XSSFWorkbook(inputStream);
		Sheet sheet = workbook.getSheet(sheetname);

		// 行号从0开始, 从第2行开始读数据
		int startRowNum = 2;
		int lastRowNum = sheet.getLastRowNum();

		List<FuncType> list = new LinkedList<>();
		FuncType temp = new FuncType();
		for (int rowIndex = startRowNum; rowIndex <= lastRowNum; rowIndex++) {
			Row row = sheet.getRow(rowIndex);
			if (row == null) {
				continue;
			}
			FuncType target = new FuncType();
			int i = 0;
			target.a = pre((String) ExcelUtils.parseCell(row.getCell(i++), "string"));// A
			target.b = (String) ExcelUtils.parseCell(row.getCell(i++), "string");// B
			if (target.a == null) {
				target.a = temp.a;
				target.b = temp.b;
			} else {
				temp.a = target.a;
				temp.b = target.b;
				temp.c = null;
				temp.d = null;
				temp.e = null;
				temp.f = null;
			}

			target.c = pre((String) ExcelUtils.parseCell(row.getCell(i++), "string"));// C
			target.d = (String) ExcelUtils.parseCell(row.getCell(i++), "string");// D
			if (target.c == null) {
				target.c = temp.c;
				target.d = temp.d;
			} else {
				temp.e = target.c;
				temp.d = target.d;
				temp.e = null;
				temp.f = null;
			}

			target.e = pre((String) ExcelUtils.parseCell(row.getCell(i++), "string"));// E
			target.f = (String) ExcelUtils.parseCell(row.getCell(i++), "string");// F
			list.add(target);
		}

		List<Item> data = new LinkedList<>();
		Set<String> codes = new HashSet<>();
		for (FuncType t : list) {
			if (t.a != null && !codes.contains(t.a)) {
				data.add(new Item(t.a, t.b, null));
				codes.add(t.a);
			}
		}
		for (FuncType t : list) {
			if (t.a != null && t.c != null && !codes.contains(t.a + t.c)) {
				if ("00".equals(t.c)) {
					data.add(new Item(t.a + t.c, t.b, t.a));
				} else {
					data.add(new Item(t.a + t.c, t.d, t.a));
				}
				codes.add(t.a + t.c);
			}
		}
		for (FuncType t : list) {
			if (t.a != null && t.c != null && t.e != null && !codes.contains(t.a + t.c + t.e)) {
				data.add(new Item(t.a + t.c + t.e, t.f, t.a + t.c));
				codes.add(t.a + t.c + t.e);
			}
		}

		for (Item item : data) {
//			System.out.println(item.code + "\t\t" + item.name + "\t\t" + item.parentCode);
			System.out.println(JacksonMapper.toSimpleJson(item));
		}
	}



	public static class FuncType{
		private String a;//
		private String b;//
		private String c;//
		private String d;
		private String e;
		private String f;
		private String g;
		private String h;
		private String i;
		private String j;
	}
}
