package com.persagy.dmp.rwd.funcid.parse.model;

import com.fasterxml.jackson.databind.node.ArrayNode;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class InfoCodeDef {

	public static final String CATEGORY_STATIC = "STATIC";
	public static final String CATEGORY_PULSE = "PULSE";
	public static final String CATEGORY_GRADATION = "GRADATION";
	public static final String CATEGORY_SEQUENTIAL = "SEQUENTIAL";

	private String code;
	private String name;
	private String category;
	private String dataType;

	/**
	 * 是否复数
	 */
	private Boolean isMultiple;
	/**
	 * 是否区间
	 */
	private Boolean isRegion;
	/**
	 * 格式
	 */
	private String formater;
	/**
	 * 数据源或约束
	 */
	private ArrayNode dataSource;
	/**
	 * 是否可以作为子分类
	 */
	private Boolean canSub;
	/**
	 * 子分类标记,是否按此信息点设置子分类
	 */
	private Boolean subFlag;

	public boolean isStatis() {
		return CATEGORY_STATIC.equals(this.category);
	}
}
