package com.persagy.dmp.rwd.funcid.parse.model;

import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class ParserResult {

	private boolean success;
	private Object value;
	private StringBuilder message;

	public ParserResult() {
		this(true);
	}

	public ParserResult(boolean success) {
		this(success, "");
	}

	public ParserResult(boolean success, String message) {
		this.success = success;
		this.message = new StringBuilder(message);
	}

	public ParserResult addError(String error) {
		if (this.success) {
			this.success = false;
		}
		this.message.append(error);
		return this;
	}

	public static ParserResult error(String message) {
		return new ParserResult(false, message);
	}
}
