package com.persagy.dmp.rwd.funcid.parse.parser;


import com.persagy.dmp.rwd.enums.FuncidDataType;
import com.persagy.dmp.rwd.funcid.parse.parser.impl.*;

public class InfoCodeParserFactory {

	private static final InfoCodeParser INTEGER = new IntegerParser();
	private static final InfoCodeParser DOUBLE = new DoubleParser();
	private static final InfoCodeParser BOOLEAN = new BooleanParser();
	private static final InfoCodeParser STRING = new StringParser();
	private static final InfoCodeParser DATETIME = new DateTimeParser();
	private static final InfoCodeParser ENUM = new EnumParser();
	private static final InfoCodeParser MENUM = new MEnumParser();
	private static final InfoCodeParser ATTACHMENT = new AttachmentParser();

	public InfoCodeParser getParser(FuncidDataType dataType) {
		if (dataType == FuncidDataType.INTEGER) {
			return INTEGER;
		} else if (dataType == FuncidDataType.DOUBLE) {
			return DOUBLE;
		} else if (dataType == FuncidDataType.BOOLEAN) {
			return BOOLEAN;
		} else if (dataType == FuncidDataType.STRING) {
			return STRING;
		} else if (dataType == FuncidDataType.DATETIME) {
			return DATETIME;
		} else if (dataType == FuncidDataType.ENUM) {
			return ENUM;
		} else if (dataType == FuncidDataType.MENUM) {
			return MENUM;
		} else if (dataType == FuncidDataType.ATTACHMENT) {
			return ATTACHMENT;
		}
		return null;
	}

}
