package com.persagy.dmp.rwd.funcid.parse.parser.impl;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.JsonNodeType;
import com.persagy.dmp.rwd.enums.FuncidCategory;
import com.persagy.dmp.rwd.funcid.parse.parser.InfoCodeParser;
import com.persagy.dmp.rwd.funcid.parse.parser.ParserContext;
import com.persagy.dmp.rwd.model.FuncidDefModel;

public abstract class AbstractParser<T> implements InfoCodeParser<T> {

	@Override
	public void checkDef(ParserContext context) {
	}

	@Override
	public void checkValue(ParserContext<T> context) {
		this.checkDef(context);
		if (context.isHasError()) {
			return;
		}

		JsonNode source = context.getSource();
		FuncidDefModel def = context.getDef();
		if (def.getCategory() != FuncidCategory.STATIC) {
			// 非静态信息点, 值应该是表号功能号
			// TODO 暂时不校验
			return;
		}
		if (source == null || source.getNodeType() == JsonNodeType.NULL) {
			context.setNull(true);
			return;
		}
	}
}


