package com.persagy.dmp.rwd.config;

import java.util.HashSet;
import java.util.Set;

/**
 * @author: yaoll
 * @date: 2020-09-23
 * @verison: 1.0
 */
public class RwdConstants {

	public static final String QUERY_GROUPCODE = "groupCode";
	public static final String QUERY_PROJECTID = "projectId";
	public static final String QUERY_USERID = "userId";
	public static final String QUERY_APPID = "appId";

	public static final Integer OBJECT_VALID_VALID = 1;
	public static final Integer OBJECT_VALID_INAVALID = 0;

	public static final String OBJECT_ID = "id";
	public static final String OBJECT_NAME = "name";
	public static final String OBJECT_LOCALID = "localId";
	public static final String OBJECT_LOCALNAME = "localName";
	public static final String OBJECT_CLASSCODE = "classCode";
	public static final String OBJECT_OBJTYPE = "objType";
	public static final String OBJECT_GROUPING = "grouping";
	public static final String OBJECT_VALID = "valid";
	public static final String OBJECT_GROUPCODE = "groupCode";
	public static final String OBJECT_PROJECTID = "projectId";
	public static final String OBJECT_VIRTUAL_INFO_CODES = "virtualInfoCodes";
	public static final String OBJECT_CREATE_TIME = "createTime";
	public static final String OBJECT_CREATE_USER = "createUser";
	public static final String OBJECT_CREATE_APP = "createApp";
	public static final String OBJECT_UPDATE_TIME = "updateTime";
	public static final String OBJECT_UPDATE_USER = "updateUser";
	public static final String OBJECT_UPDATE_APP = "updateApp";

	public static final String OBJECT_UPDATE_REMOVE = "$remove";

	public static final String RELATION_OBJ_FROM = "objFrom";
	public static final String RELATION_OBJ_TO = "objTo";

	private static final Set<String> OBJECT_BASIC_COLUMNS = new HashSet<>();

	static {
		OBJECT_BASIC_COLUMNS.add(OBJECT_ID);
		OBJECT_BASIC_COLUMNS.add(OBJECT_NAME);
		OBJECT_BASIC_COLUMNS.add(OBJECT_LOCALID);
		OBJECT_BASIC_COLUMNS.add(OBJECT_LOCALNAME);
		OBJECT_BASIC_COLUMNS.add(OBJECT_CLASSCODE);
		OBJECT_BASIC_COLUMNS.add(OBJECT_OBJTYPE);
		OBJECT_BASIC_COLUMNS.add(OBJECT_GROUPING);
		OBJECT_BASIC_COLUMNS.add(OBJECT_VALID);
		OBJECT_BASIC_COLUMNS.add(OBJECT_GROUPCODE);
		OBJECT_BASIC_COLUMNS.add(OBJECT_PROJECTID);
		OBJECT_BASIC_COLUMNS.add(OBJECT_VIRTUAL_INFO_CODES);
		OBJECT_BASIC_COLUMNS.add(OBJECT_CREATE_TIME);
		OBJECT_BASIC_COLUMNS.add(OBJECT_CREATE_USER);
		OBJECT_BASIC_COLUMNS.add(OBJECT_CREATE_APP);
		OBJECT_BASIC_COLUMNS.add(OBJECT_UPDATE_TIME);
		OBJECT_BASIC_COLUMNS.add(OBJECT_UPDATE_USER);
		OBJECT_BASIC_COLUMNS.add(OBJECT_UPDATE_APP);
	}

	public static final boolean isBasicColumn(String column){
		return OBJECT_BASIC_COLUMNS.contains(column);
	}

	public static final String MESSAGE_INSTANCE_OBJECT_CREATE = "instanceObjectCreate";
	public static final String MESSAGE_INSTANCE_OBJECT_UPDATE = "instanceObjectUpdate";
	public static final String MESSAGE_INSTANCE_OBJECT_DELETE = "instanceObjectDelete";
	public static final String MESSAGE_INSTANCE_RELATION_CREATE = "instanceRelationCreate";
	public static final String MESSAGE_INSTANCE_RELATION_DELETE = "instanceRelationDelete";
	public static final String MESSAGE_ORG_GROUP_CREATE = "groupCreate";
	public static final String MESSAGE_ORG_PROJECT_CREATE = "projectCreate";
}
