package com.persagy.dmp.rwd.config;

import com.persagy.common.json.JacksonMapper;
import com.persagy.dmp.config.DmpParameterStorage;
import org.springframework.amqp.support.converter.Jackson2JsonMessageConverter;
import org.springframework.amqp.support.converter.MessageConverter;
import org.springframework.boot.autoconfigure.http.HttpMessageConverters;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.converter.json.MappingJackson2HttpMessageConverter;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * @author: yaoll
 * @date: 2020-09-22
 * @verison: 1.0
 */
@Configuration
public class WebConfig implements WebMvcConfigurer {

	@Bean
	public DmpParameterStorage dmpParameterStorage() {
		return new DmpParameterStorage();
	}

	@Override
	public void addInterceptors(InterceptorRegistry registry) {
		// 设置拦截的路径、不拦截的路径、优先级等等
		registry.addInterceptor(dmpParameterStorage()).addPathPatterns("/**");
	}

	@Bean
	public HttpMessageConverters customConverters() {
		MappingJackson2HttpMessageConverter converter = new MappingJackson2HttpMessageConverter();
		converter.setObjectMapper(JacksonMapper.nonEmptyMapper);
		return new HttpMessageConverters(converter);
	}

	// JMS
	@Bean
	public MessageConverter customMessageConvert() {
		return new Jackson2JsonMessageConverter();
	}

}
