package com.persagy.dmp.rwd.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.model.AppClassModel;
import com.persagy.dmp.rwd.service.AppClassService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
@RestController
@RequestMapping("/rwd/subscribe/app/class")
public class AppClassController {
	@Autowired
	private AppClassService service;
	
	@PostMapping("/query")
	public PagedResponse<AppClassModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody AppClassModel param){
		return service.create(param);
	}
	
	@PostMapping("/update")
	public MapResponse update(@RequestBody AppClassModel param){
		return service.update(param);
	}
	
	@PostMapping("/delete")
	public MapResponse delete(@RequestBody AppClassModel param){
		return service.delete(param);
	}
	
}
