package com.persagy.dmp.rwd.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.ListResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.model.FuncidDefModel;
import com.persagy.dmp.rwd.service.FuncidDefService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/rwd/def/funcid")
public class FuncidDefController {
	@Autowired
	private FuncidDefService service;

	@PostMapping("")
	public ListResponse<FuncidDefModel> query(@RequestParam(name = "groupCode", required = false) String groupCode,
											  @RequestParam(name = "schemaId", required = false) String schemaId,
											  @RequestParam(name = "projectId", required = false) String projectId,
											  @RequestParam(name = "appId", required = false) String appId,
											  @RequestBody JacksonCriteria criteria) {
		return service.queryFuncid(groupCode, schemaId, projectId, appId, criteria);
	}

	@PostMapping("/query")
	public PagedResponse<FuncidDefModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}


//	@PostMapping("/create")
//	public MapResponse create(@RequestBody FuncidDefModel param){
//		return service.create(param);
//	}
//
//	@PostMapping("/update")
//	public MapResponse update(@RequestBody FuncidDefModel param){
//		return service.update(param);
//	}
//
//	@PostMapping("/delete")
//	public MapResponse delete(@RequestBody FuncidDefModel param){
//		return service.delete(param);
//	}

}
