package com.persagy.dmp.rwd.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.model.GraphDefModel;
import com.persagy.dmp.rwd.service.GraphDefService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
@RestController
@RequestMapping("/rwd/def/graph")
public class GraphDefController {
	@Autowired
	private GraphDefService service;
	
	@PostMapping("/query")
	public PagedResponse<GraphDefModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody GraphDefModel param){
		return service.create(param);
	}
	
	@PostMapping("/update")
	public MapResponse update(@RequestBody GraphDefModel param){
		return service.update(param);
	}
	
	@PostMapping("/delete")
	public MapResponse delete(@RequestBody GraphDefModel param){
		return service.delete(param);
	}
	
}
