package com.persagy.dmp.rwd.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.model.GraphInstanceModel;
import com.persagy.dmp.rwd.service.GraphInstanceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
@RestController
@RequestMapping("/rwd/instance/graph")
public class GraphInstanceController {
	@Autowired
	private GraphInstanceService service;
	
	@PostMapping("/query")
	public PagedResponse<GraphInstanceModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody GraphInstanceModel param){
		return service.create(param);
	}
	
	@PostMapping("/update")
	public MapResponse update(@RequestBody GraphInstanceModel param){
		return service.update(param);
	}
	
	@PostMapping("/delete")
	public MapResponse delete(@RequestBody GraphInstanceModel param){
		return service.delete(param);
	}
	
}
