package com.persagy.dmp.rwd.controller;

import com.persagy.common.web.ListResponse;
import com.persagy.dmp.rwd.model.iot.CurrentDataModel;
import com.persagy.dmp.rwd.model.iot.SettingDataModel;
import com.persagy.dmp.rwd.model.iot.history.InfoCodeModel;
import com.persagy.dmp.rwd.model.iot.history.RequestModel;
import com.persagy.dmp.rwd.service.iot.CurrentIotService;
import com.persagy.dmp.rwd.service.iot.HistoryIotService;
import com.persagy.dmp.rwd.service.iot.SettingIotService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author: yaoll
 * @date: 2020-10-14
 * @verison: 1.0
 */
@RestController
@RequestMapping("/rwd/iot")
public class IotController {


	@Autowired
	private CurrentIotService currentDataService;

	@Autowired
	private HistoryIotService historyDataService;

	@Autowired
	private SettingIotService settingDataService;

	@PostMapping("/data/current")
	public ListResponse<CurrentDataModel> current(@RequestBody List<CurrentDataModel> param) {
		return currentDataService.getCurrentData(param);
	}

	@PostMapping("/data/history")
	public ListResponse<InfoCodeModel> history(@RequestBody RequestModel request) {
		return historyDataService.getHistroyData(request);
	}

	@PostMapping("/funcid/setting")
	public ListResponse<SettingDataModel> setting(@RequestBody List<SettingDataModel> param) {
		return settingDataService.setting(param);
	}

	@PostMapping("/funcid/settingQuery")
	public ListResponse<SettingDataModel> settingQuery(@RequestBody List<String> param) {
		return settingDataService.settingQuery(param);
	}
}
