package com.persagy.dmp.rwd.controller;

import com.fasterxml.jackson.databind.node.ArrayNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/rwd/instance/object")
public class ObjectInstanceController {

    @Autowired
    private ObjectInstanceCreateService createService;

    @Autowired
    private ObjectInstanceUpdateService updateService;

    @Autowired
    private ObjectInstanceDeleteService deleteService;

    @Autowired
    private ObjectInstanceQueryService queryService;

    @PostMapping("/query")
    public PagedResponse<ObjectNode> query(@RequestBody JacksonCriteria criteria) {
        return queryService.query(criteria);
    }

    @PostMapping("/create")
    public MapResponse create(@RequestBody ArrayNode paramList) {
        return createService.create(paramList);
    }

    @PostMapping("/update")
    public MapResponse update(@RequestBody ArrayNode paramList) {
        return updateService.update(paramList);
    }

    @PostMapping("/delete")
    public MapResponse delete(@RequestBody List<String> idList) {
        return deleteService.delete(idList);
    }

}
