package com.persagy.dmp.rwd.controller;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.model.RelationInstanceModel;
import com.persagy.dmp.rwd.service.RelationInstanceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/rwd/instance/relation")
public class RelationInstanceController {
	@Autowired
	private RelationInstanceService service;

	@PostMapping("/query")
	public PagedResponse<RelationInstanceModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}

	@PostMapping("/create")
	public MapResponse create(@RequestBody List<RelationInstanceModel> paramList) {
		return service.create(paramList);
	}

//	@PostMapping("/update")
//	public MapResponse update(@RequestBody List<RelationInstanceModel> paramList) {
//		return service.update(paramList);
//	}

	@PostMapping("/delete")
	public MapResponse delete(@RequestBody JacksonCriteria criteria) {
		return service.delete(criteria);
	}

	@PostMapping("/object/query")
	public PagedResponse<ObjectNode> queryObject(@RequestBody JacksonCriteria criteria) {
		return service.queryObject(criteria);
	}
}
