package com.persagy.dmp.rwd.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.model.SchemaProjectModel;
import com.persagy.dmp.rwd.service.SchemaProjectService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
@RestController
@RequestMapping("/rwd/schema/project")
public class SchemaProjectController {
	@Autowired
	private SchemaProjectService service;
	
	@PostMapping("/query")
	public PagedResponse<SchemaProjectModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody SchemaProjectModel param){
		return service.create(param);
	}
	
//	@PostMapping("/update")
//	public MapResponse update(@RequestBody SchemaProjectModel param){
//		return service.update(param);
//	}
	
	@PostMapping("/delete")
	public MapResponse delete(@RequestBody SchemaProjectModel param){
		return service.delete(param);
	}
	
}
