package com.persagy.dmp.rwd.entity;

import com.persagy.dmp.rwd.model.AppClassModel;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.Table;

@Setter
@Getter
@Entity
@Table(name = "rwd_app_class")
@IdClass(GroupPK.class)
public class AppClass {

	@Id
	private String id;
	@Id
	private String groupCode;
	private String appId;
	private String projectId;
	private String classCode;

	public static AppClass fromModel(AppClassModel model) {
		AppClass entity = new AppClass();
		entity.setId(model.getId());
		entity.setAppId(model.getAppId());
		entity.setGroupCode(model.getGroupCode());
		entity.setProjectId(model.getProjectId());
		entity.setClassCode(model.getClassCode());
		return entity;
	}

	public AppClassModel toModel() {
		AppClassModel model = new AppClassModel();
		model.setId(this.id);
		model.setAppId(this.getAppId());
		model.setGroupCode(this.groupCode);
		model.setProjectId(this.projectId);
		model.setClassCode(this.getClassCode());
		return model;
	}

}
