package com.persagy.dmp.rwd.entity;

import com.persagy.dmp.rwd.model.AppFuncidModel;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.Table;

@Setter
@Getter
@Entity
@Table(name = "rwd_app_funcid")
@IdClass(GroupPK.class)
public class AppFuncid {

	@Id
	private String id;
	@Id
	private String groupCode;
	private String appId;
	private String projectId;
	private String classCode;
	private String infoCode;

	public static AppFuncid fromModel(AppFuncidModel model) {
		AppFuncid entity = new AppFuncid();
		entity.setId(model.getId());
		entity.setAppId(model.getAppId());
		entity.setGroupCode(model.getGroupCode());
		entity.setProjectId(model.getProjectId());
		entity.setClassCode(model.getClassCode());
		entity.setInfoCode(model.getInfoCode());
		return entity;
	}

	public AppFuncidModel toModel() {
		AppFuncidModel model = new AppFuncidModel();
		model.setId(this.id);
		model.setAppId(this.getAppId());
		model.setGroupCode(this.getGroupCode());
		model.setProjectId(this.getProjectId());
		model.setClassCode(this.getClassCode());
		model.setInfoCode(this.getInfoCode());
		return model;
	}

}
