package com.persagy.dmp.rwd.entity;

import com.persagy.dmp.rwd.enums.ObjType;
import com.persagy.dmp.rwd.model.ClassDefModel;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;

@Setter
@Getter
@Entity
@Table(name = "rwd_def_class")
@IdClass(GroupPK.class)
public class ClassDef {

	@Id
	private String id;
	@Id
	private String groupCode;
	private String code;
	@Enumerated(value = EnumType.STRING)
	private ObjType objType;
	private String name;
	private String aliasCode;
	private String aliasName;
	private String type;
	private String projectId;
	private String majorCode;
	private String systemCode;
	private String equipmentCode;
	private String parentCode;

	public static ClassDef fromModel(ClassDefModel model) {
		ClassDef entity = new ClassDef();
		entity.setId(model.getId());
		entity.setCode(model.getCode());
		entity.setObjType(model.getObjType());
		entity.setName(model.getName());
		entity.setAliasCode(model.getAliasCode());
		entity.setAliasName(model.getAliasName());
		entity.setType(model.getType());
		entity.setGroupCode(model.getGroupCode());
		entity.setProjectId(model.getProjectId());
		entity.setMajorCode(model.getMajorCode());
		entity.setSystemCode(model.getSystemCode());
		entity.setEquipmentCode(model.getEquipmentCode());
		entity.setParentCode(model.getParentCode());
		return entity;
	}

	public ClassDefModel toModel() {
		ClassDefModel model = new ClassDefModel();
		model.setId(this.getId());
		model.setCode(this.getCode());
		model.setObjType(this.getObjType());
		model.setName(this.getName());
		model.setAliasCode(this.getAliasCode());
		model.setAliasName(this.getAliasName());
		model.setType(this.getType());
		model.setGroupCode(this.getGroupCode());
		model.setProjectId(this.getProjectId());
		model.setMajorCode(this.getMajorCode());
		model.setSystemCode(this.getSystemCode());
		model.setEquipmentCode(this.getEquipmentCode());
		model.setParentCode(this.getParentCode());
		return model;
	}

}
