package com.persagy.dmp.rwd.entity;

import com.fasterxml.jackson.databind.node.ArrayNode;
import com.persagy.dmp.rwd.enums.FuncidCategory;
import com.persagy.dmp.rwd.enums.FuncidDataType;
import com.persagy.dmp.rwd.model.FuncidDefModel;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.Type;

import javax.persistence.*;

@Setter
@Getter
@Entity
@Table(name = "rwd_def_funcid")
@IdClass(GroupPK.class)
public class FuncidDef {

	@Id
	private String id;
	@Id
	private String groupCode;
	@Column(updatable = false)
	private String projectId;
	private String code;
	private String origCode;
	private String name;
	private String aliasCode;
	private String aliasName;
	@Column(updatable = false)
	private String classCode;
	@Enumerated(EnumType.STRING)
	private FuncidCategory category;
	private String type;
	private String firstTag;
	private String secondTag;
	private String priority;
	private String inputMode;
	private String unit;
	@Enumerated(EnumType.STRING)
	private FuncidDataType dataType;
	private String origDataType;
	private Boolean isMultiple = false;
	private Boolean isRegion = false;
	private String formater;

	@Type(type = "json")
	private ArrayNode dataSource;
	private String note;
	private Boolean subFlag;
	private Boolean weakPoint;

	public static FuncidDef fromModel(FuncidDefModel model) {
		FuncidDef entity = new FuncidDef();
		entity.setId(model.getId());
		entity.setCode(model.getCode());
		entity.setOrigCode(model.getOrigCode());
		entity.setName(model.getName());
		entity.setAliasCode(model.getAliasCode());
		entity.setAliasName(model.getAliasName());
		entity.setClassCode(model.getClassCode());
		entity.setCategory(model.getCategory());
		entity.setType(model.getType());
		entity.setGroupCode(model.getGroupCode());
		entity.setProjectId(model.getProjectId());
		entity.setFirstTag(model.getFirstTag());
		entity.setSecondTag(model.getSecondTag());
		entity.setPriority(model.getPriority());
		entity.setInputMode(model.getInputMode());
		entity.setUnit(model.getUnit());
		entity.setDataType(model.getDataType());
		entity.setOrigDataType(model.getOrigDataType());
		entity.setIsMultiple(model.getIsMultiple());
		entity.setIsRegion(model.getIsRegion());
		entity.setFormater(model.getFormater());
		entity.setDataSource(model.getDataSource());
		entity.setNote(model.getNote());
		entity.setSubFlag(model.getSubFlag());
		entity.setWeakPoint(model.getWeakPoint());
		return entity;
	}

	public FuncidDefModel toModel() {
		FuncidDefModel model = new FuncidDefModel();
		model.setId(this.id);
		model.setCode(this.getCode());
		model.setOrigCode(this.getOrigCode());
		model.setName(this.getName());
		model.setAliasCode(this.aliasCode);
		model.setAliasName(this.aliasName);
		model.setClassCode(this.getClassCode());
		model.setCategory(this.getCategory());
		model.setType(this.getType());
		model.setGroupCode(this.getGroupCode());
		model.setProjectId(this.getProjectId());
		model.setFirstTag(this.getFirstTag());
		model.setSecondTag(this.getSecondTag());
		model.setPriority(this.getPriority());
		model.setInputMode(this.getInputMode());
		model.setUnit(this.getUnit());
		model.setDataType(this.getDataType());
		model.setOrigDataType(this.getOrigDataType());
		model.setIsMultiple(this.getIsMultiple());
		model.setIsRegion(this.getIsRegion());
		model.setFormater(this.getFormater());
		model.setDataSource(this.getDataSource());
		model.setNote(this.getNote());
		model.setSubFlag(this.getSubFlag());
		model.setWeakPoint(this.getWeakPoint());
		return model;
	}

}
