package com.persagy.dmp.rwd.entity;

import com.persagy.dmp.rwd.model.GraphDefModel;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

@Setter
@Getter
@Entity
@Table(name = "rwd_def_graph")
public class GraphDef {

	@Id
	@GeneratedValue(generator = "assignedId")
	@GenericGenerator(name = "assignedId", strategy = "assigned")
	private String id;
	private String code;
	private String name;
	private String firstCategory;
	private String secondCategory;
	private String categoryRemark;
	private String objectTypes;

	public static GraphDef fromModel(GraphDefModel model) {
		GraphDef entity = new GraphDef();
		entity.setId(model.getId());
		entity.setCode(model.getCode());
		entity.setName(model.getName());
		entity.setFirstCategory(model.getFirstCategory());
		entity.setSecondCategory(model.getSecondCategory());
		entity.setCategoryRemark(model.getCategoryRemark());
		entity.setObjectTypes(model.getObjectTypes());
		return entity;
	}

	public GraphDefModel toModel() {
		GraphDefModel model = new GraphDefModel();
		model.setId(this.id);
		model.setCode(this.getCode());
		model.setName(this.getName());
		model.setFirstCategory(this.getFirstCategory());
		model.setSecondCategory(this.getSecondCategory());
		model.setCategoryRemark(this.getCategoryRemark());
		model.setObjectTypes(this.getObjectTypes());
		return model;
	}

}
