package com.persagy.dmp.rwd.entity;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.dmp.rwd.model.GraphInstanceModel;
import com.vladmihalcea.hibernate.type.json.JsonStringType;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Type;
import org.hibernate.annotations.TypeDef;

import javax.persistence.*;

@Setter
@Getter
@Entity
@Table(name = "rwd_graph")
@TypeDef(name = "json", typeClass = JsonStringType.class)
@IdClass(GroupProjectPK.class)
public class GraphInstance {

	@Id
	private String id;
	@Id
	private String groupCode;
	@Id
	private String projectId;
	private String graphCode;
	@Type(type = "json")
	private ObjectNode infos;

	public static GraphInstance fromModel(GraphInstanceModel model) {
		GraphInstance entity = new GraphInstance();
		entity.setId(model.getId());
		entity.setProjectId(model.getProjectId());
		entity.setGraphCode(model.getGraphCode());
		entity.setInfos(model.getInfos());
		return entity;
	}

	public GraphInstanceModel toModel() {
		GraphInstanceModel model = new GraphInstanceModel();
		model.setId(this.id);
		model.setProjectId(this.projectId);
		model.setGraphCode(this.getGraphCode());
		model.setInfos(this.getInfos());
		return model;
	}

}
