package com.persagy.dmp.rwd.entity;

import javax.persistence.Column;
import javax.persistence.Embeddable;
import java.io.Serializable;
import java.util.Objects;

/**
 * @author: yaoll
 * @date: 2020-11-01
 * @verison: 1.0
 */
@Embeddable
public class GroupProjectPK implements Serializable {

	@Column
	private String id;

	@Column
	private String groupCode;

	@Column
	private String projectId;

	public GroupProjectPK() {
	}

	public GroupProjectPK(String id, String groupCode, String projectId) {
		this.id = id;
		this.groupCode = groupCode;
		this.projectId = projectId;
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) return true;
		if (o == null || getClass() != o.getClass()) return false;
		GroupProjectPK that = (GroupProjectPK) o;
		return id.equals(that.id) &&
				groupCode.equals(that.groupCode) &&
				projectId.equals(that.projectId);
	}

	@Override
	public int hashCode() {
		return Objects.hash(id, groupCode, projectId);
	}

	@Override
	public String toString() {
		return "GroupProjectPK{id=\"" + id + "\", groupCode=\"" + groupCode + "\", projectId=\"" + projectId + "\"}";
	}
}
