package com.persagy.dmp.rwd.entity;

import com.persagy.dmp.rwd.model.RelDefModel;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

@Setter
@Getter
@Entity
@Table(name = "rwd_def_rel")
public class RelDef {

	@Id
	@GeneratedValue(generator = "assignedId")
	@GenericGenerator(name = "assignedId", strategy = "assigned")
	private String id;
	private String code;
	private String name;
	private String graphCode;
	private Integer directional;
	private String attribute;
	private String targetObjs;

	public static RelDef fromModel(RelDefModel model) {
		RelDef entity = new RelDef();
		entity.setId(model.getId());
		entity.setCode(model.getCode());
		entity.setName(model.getName());
		entity.setGraphCode(model.getGraphCode());
		entity.setDirectional(model.getDirectional());
		entity.setAttribute(model.getAttribute());
		entity.setTargetObjs(model.getTargetObjs());
		return entity;
	}

	public RelDefModel toModel() {
		RelDefModel model = new RelDefModel();
		model.setId(this.id);
		model.setCode(this.getCode());
		model.setName(this.getName());
		model.setGraphCode(this.getGraphCode());
		model.setDirectional(this.getDirectional());
		model.setAttribute(this.getAttribute());
		model.setTargetObjs(this.getTargetObjs());
		return model;
	}

}
