package com.persagy.dmp.rwd.entity;

import com.persagy.dmp.rwd.model.RelationInstanceModel;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.UpdateTimestamp;

import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "rwd_relation")
@IdClass(GroupProjectPK.class)
public class RelationInstance {

	@Id
	private String id;
	@Id
	private String groupCode;
	@Id
	private String projectId;
	@Column(updatable = false)
	private String graphId;
	@Column(updatable = false)
	private String graphCode;
	@Column(updatable = false)
	private String relCode;
	@Column(updatable = false)
	private String objFrom;
	@Column(updatable = false)
	private String objTo;
	private Integer status;
	@Column(updatable = false)
	@CreationTimestamp
	private Date createTime;
	@UpdateTimestamp
	private Date updateTime;
	@Column(updatable = false)
	private String createUser;
	private String updateUser;
	@Column(updatable = false)
	private String createApp;
	private String updateApp;

	public static RelationInstance fromModel(RelationInstanceModel model) {
		RelationInstance entity = new RelationInstance();
		entity.setId(model.getId());
		entity.setProjectId(model.getProjectId());
		entity.setGraphId(model.getGraphId());
		entity.setGraphCode(model.getGraphCode());
		entity.setRelCode(model.getRelCode());
		entity.setObjFrom(model.getObjFrom());
		entity.setObjTo(model.getObjTo());
		entity.setStatus(model.getStatus());
		entity.setCreateTime(model.getCreateTime());
		entity.setUpdateTime(model.getUpdateTime());
		entity.setCreateUser(model.getCreateUser());
		entity.setUpdateUser(model.getUpdateUser());
		entity.setCreateApp(model.getCreateApp());
		entity.setUpdateApp(model.getUpdateApp());
		return entity;
	}

	public RelationInstanceModel toModel() {
		RelationInstanceModel model = new RelationInstanceModel();
		model.setId(this.id);
		model.setProjectId(this.projectId);
		model.setGraphId(this.getGraphId());
		model.setGraphCode(this.getGraphCode());
		model.setRelCode(this.getRelCode());
		model.setObjFrom(this.getObjFrom());
		model.setObjTo(this.getObjTo());
		model.setStatus(this.getStatus());
		model.setCreateTime(this.getCreateTime());
		model.setUpdateTime(this.getUpdateTime());
		model.setCreateUser(this.getCreateUser());
		model.setUpdateUser(this.getUpdateUser());
		model.setCreateApp(this.getCreateApp());
		model.setUpdateApp(this.getUpdateApp());
		return model;
	}

}
