package com.persagy.dmp.rwd.entity;

import com.persagy.dmp.rwd.model.SchemaModel;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.Table;

@Setter
@Getter
@Entity
@Table(name = "rwd_schema")
@IdClass(GroupPK.class)
public class Schema {

	@Id
	private String id;
	@Id
	private String groupCode;
	private String name;
	private String remark;
	private Integer status;

	public static Schema fromModel(SchemaModel model) {
		Schema entity = new Schema();
		entity.setId(model.getId());
		entity.setName(model.getName());
		entity.setGroupCode(model.getGroupCode());
		entity.setRemark(model.getRemark());
		entity.setStatus(model.getStatus());
		return entity;
	}

	public SchemaModel toModel() {
		SchemaModel model = new SchemaModel();
		model.setId(this.id);
		model.setName(this.getName());
		model.setGroupCode(this.getGroupCode());
		model.setRemark(this.getRemark());
		model.setStatus(this.getStatus());
		return model;
	}

}
