package com.persagy.dmp.rwd.entity;

import com.persagy.dmp.rwd.model.SchemaClassModel;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.Table;

@Setter
@Getter
@Entity
@Table(name = "rwd_schema_class")
@IdClass(GroupPK.class)
public class SchemaClass {

	@Id
	private String id;
	@Id
	private String groupCode;
	private String schemaId;
	private String classCode;

	public static SchemaClass fromModel(SchemaClassModel model) {
		SchemaClass entity = new SchemaClass();
		entity.setId(model.getId());
		entity.setGroupCode(model.getGroupCode());
		entity.setSchemaId(model.getSchemaId());
		entity.setClassCode(model.getClassCode());
		return entity;
	}

	public SchemaClassModel toModel() {
		SchemaClassModel model = new SchemaClassModel();
		model.setId(this.id);
		model.setGroupCode(this.groupCode);
		model.setSchemaId(this.getSchemaId());
		model.setClassCode(this.getClassCode());
		return model;
	}

}
