package com.persagy.dmp.rwd.entity;

import com.persagy.dmp.rwd.model.SchemaFuncidModel;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.Table;

@Setter
@Getter
@Entity
@Table(name = "rwd_schema_funcid")
@IdClass(GroupPK.class)
public class SchemaFuncid {

	@Id
	private String id;
	@Id
	private String groupCode;
	private String schemaId;
	private String classCode;
	private String infoCode;

	public static SchemaFuncid fromModel(SchemaFuncidModel model) {
		SchemaFuncid entity = new SchemaFuncid();
		entity.setId(model.getId());
		entity.setGroupCode(model.getGroupCode());
		entity.setSchemaId(model.getSchemaId());
		entity.setClassCode(model.getClassCode());
		entity.setInfoCode(model.getInfoCode());
		return entity;
	}

	public SchemaFuncidModel toModel() {
		SchemaFuncidModel model = new SchemaFuncidModel();
		model.setId(this.id);
		model.setGroupCode(this.groupCode);
		model.setSchemaId(this.getSchemaId());
		model.setClassCode(this.getClassCode());
		model.setInfoCode(this.getInfoCode());
		return model;
	}

}
