package com.persagy.dmp.rwd.entity;

import com.persagy.dmp.rwd.model.SchemaProjectModel;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.Table;

@Setter
@Getter
@Entity
@Table(name = "rwd_schema_project")
@IdClass(GroupPK.class)
public class SchemaProject {

	@Id
	private String id;
	@Id
	private String groupCode;
	private String schemaId;
	private String projectId;

	public static SchemaProject fromModel(SchemaProjectModel model) {
		SchemaProject entity = new SchemaProject();
		entity.setId(model.getId());
		entity.setGroupCode(model.getGroupCode());
		entity.setSchemaId(model.getSchemaId());
		entity.setProjectId(model.getProjectId());
		return entity;
	}

	public SchemaProjectModel toModel() {
		SchemaProjectModel model = new SchemaProjectModel();
		model.setId(this.id);
		model.setGroupCode(this.groupCode);
		model.setSchemaId(this.getSchemaId());
		model.setProjectId(this.getProjectId());
		return model;
	}

}
