package com.persagy.dmp.rwd.feign;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.PagedResponse;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.Map;

/**
 * @author: yaoll
 * @date: 2020-10-30
 * @verison: 1.0
 */
@FeignClient(name = "dmp-org")
public interface OrgClient {

	@PostMapping("/org/group/query")
	PagedResponse<Map<String, Object>> queryGroup(@RequestParam(name = "userId") String userId,
												  @RequestParam(name = "appId") String appId,
												  @RequestBody JacksonCriteria criteria);

	@PostMapping("/org/project/query")
	PagedResponse<Map<String, Object>> queryProject(@RequestParam(name = "groupCode") String groupCode,
													@RequestParam(name = "userId") String userId,
													@RequestParam(name = "appId") String appId,
													@RequestBody JacksonCriteria criteria);
}
