package com.persagy.dmp.rwd.service;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.config.DmpParameterStorage;
import com.persagy.dmp.rwd.config.RwdConstants;
import com.persagy.dmp.rwd.entity.AppFuncid;
import com.persagy.dmp.rwd.entity.QAppFuncid;
import com.persagy.dmp.rwd.model.AppFuncidModel;
import com.querydsl.core.types.dsl.BooleanExpression;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class AppFuncidService extends BaseService{

	private List<BooleanExpression> parse(ObjectNode criteria) {
		// TODO
		return null;
	}

	public PagedResponse<AppFuncidModel> query(JacksonCriteria criteria) {
		PagedResponse<AppFuncidModel> result = new PagedResponse<>();
		super.checkParam(result, RwdConstants.QUERY_GROUPCODE);
		if (!result.success()) {
			return result;
		}
		if (!criteria.getCriteria().has("groupCode")) {
			criteria.add("groupCode", DmpParameterStorage.getGroupCode());
		}
		PagedResponse<AppFuncid> resp = criteriaUtils.query(QAppFuncid.appFuncid, this::parse, criteria);
		result.setCount(resp.getCount());
		List<AppFuncid> dataList = resp.getData();
		if (dataList != null && dataList.size() > 0) {
			List<AppFuncidModel> collect = dataList.stream().map(entity -> {
				AppFuncidModel model = entity.toModel();
				return model;
			}).collect(Collectors.toList());
			result.setData(collect);
		}
		return result;
	}

	@Transactional
	public MapResponse create(AppFuncidModel param) {
		MapResponse response = new MapResponse();
		super.checkParam(response, RwdConstants.QUERY_GROUPCODE);
		if (!response.success()) {
			return response;
		}
		// TODO
		AppFuncid entity = AppFuncid.fromModel(param);
		entity.setGroupCode(DmpParameterStorage.getGroupCode());
		appFuncidRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse update(AppFuncidModel param) {
		MapResponse response = new MapResponse();
		super.checkParam(response, RwdConstants.QUERY_GROUPCODE);
		if (!response.success()) {
			return response;
		}
		// TODO
		AppFuncid entity = AppFuncid.fromModel(param);
		appFuncidRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse delete(AppFuncidModel param) {
		MapResponse response = new MapResponse();
		super.checkParam(response, RwdConstants.QUERY_GROUPCODE);
		if (!response.success()) {
			return response;
		}
		// TODO
		appFuncidRepository.deleteById(param.getId());
		return response;
	}
}

