package com.persagy.dmp.rwd.service;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.CriteriaUtils;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.entity.GraphDef;
import com.persagy.dmp.rwd.entity.QGraphDef;
import com.persagy.dmp.rwd.model.GraphDefModel;
import com.persagy.dmp.rwd.repository.GraphDefRepository;
import com.querydsl.core.types.dsl.BooleanExpression;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class GraphDefService {

	@Autowired
	private GraphDefRepository graphDefRepository;

	@Autowired
	private CriteriaUtils criteriaUtils;

	private List<BooleanExpression> parse(ObjectNode criteria) {
		// TODO
		return null;
	}

	public PagedResponse<GraphDefModel> query(JacksonCriteria criteria) {
		PagedResponse<GraphDef> resp = criteriaUtils.query(QGraphDef.graphDef, this::parse, criteria);
		PagedResponse<GraphDefModel> result = new PagedResponse<>();
		result.setCount(resp.getCount());
		List<GraphDef> dataList = resp.getData();
		if (dataList != null && dataList.size() > 0) {
			List<GraphDefModel> collect = dataList.stream().map(entity -> {
				GraphDefModel model = entity.toModel();
				return model;
			}).collect(Collectors.toList());
			result.setData(collect);
		}
		return result;
	}

	@Transactional
	public MapResponse create(GraphDefModel param) {
		MapResponse response = new MapResponse();
		// TODO
		GraphDef entity = GraphDef.fromModel(param);
		graphDefRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse update(GraphDefModel param) {
		MapResponse response = new MapResponse();
		// TODO
		GraphDef entity = GraphDef.fromModel(param);
		graphDefRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse delete(GraphDefModel param) {
		MapResponse response = new MapResponse();
		// TODO
		graphDefRepository.deleteById(param.getId());
		return response;
	}
}

