package com.persagy.dmp.rwd.service;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.CriteriaUtils;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.config.DmpParameterStorage;
import com.persagy.dmp.rwd.config.RwdConstants;
import com.persagy.dmp.rwd.entity.GraphInstance;
import com.persagy.dmp.rwd.entity.QGraphInstance;
import com.persagy.dmp.rwd.model.GraphInstanceModel;
import com.persagy.dmp.rwd.repository.GraphInstanceRepository;
import com.querydsl.core.types.dsl.BooleanExpression;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class GraphInstanceService {

	@Autowired
	private GraphInstanceRepository graphInstanceRepository;

	@Autowired
	private CriteriaUtils criteriaUtils;

	private List<BooleanExpression> parse(ObjectNode criteria) {
		// TODO
		return null;
	}

	public PagedResponse<GraphInstanceModel> query(JacksonCriteria criteria) {
		criteria.add(RwdConstants.OBJECT_PROJECTID, DmpParameterStorage.getProjectId());
		PagedResponse<GraphInstance> resp = criteriaUtils.query(QGraphInstance.graphInstance, this::parse, criteria);
		PagedResponse<GraphInstanceModel> result = new PagedResponse<>();
		result.setCount(resp.getCount());
		List<GraphInstance> dataList = resp.getData();
		if (dataList != null && dataList.size() > 0) {
			List<GraphInstanceModel> collect = dataList.stream().map(entity -> {
				GraphInstanceModel model = entity.toModel();
				return model;
			}).collect(Collectors.toList());
			result.setData(collect);
		}
		return result;
	}

	@Transactional
	public MapResponse create(GraphInstanceModel param) {
		MapResponse response = new MapResponse();
		// TODO
		GraphInstance entity = GraphInstance.fromModel(param);
		graphInstanceRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse update(GraphInstanceModel param) {
		MapResponse response = new MapResponse();
		// TODO
		GraphInstance entity = GraphInstance.fromModel(param);
		graphInstanceRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse delete(GraphInstanceModel param) {
		MapResponse response = new MapResponse();
		// TODO
		graphInstanceRepository.deleteById(param.getId());
		return response;
	}
}

