package com.persagy.dmp.rwd.service;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.CriteriaUtils;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.entity.QRelDef;
import com.persagy.dmp.rwd.entity.RelDef;
import com.persagy.dmp.rwd.model.RelDefModel;
import com.persagy.dmp.rwd.repository.RelDefRepository;
import com.querydsl.core.types.dsl.BooleanExpression;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class RelDefService {

	@Autowired
	private RelDefRepository relDefRepository;

	@Autowired
	private CriteriaUtils criteriaUtils;

	private List<BooleanExpression> parse(ObjectNode criteria) {
		// TODO
		return null;
	}

	public PagedResponse<RelDefModel> query(JacksonCriteria criteria) {
		PagedResponse<RelDef> resp = criteriaUtils.query(QRelDef.relDef, this::parse, criteria);
		PagedResponse<RelDefModel> result = new PagedResponse<>();
		result.setCount(resp.getCount());
		List<RelDef> dataList = resp.getData();
		if (dataList != null && dataList.size() > 0) {
			List<RelDefModel> collect = dataList.stream().map(entity -> {
				RelDefModel model = entity.toModel();
				return model;
			}).collect(Collectors.toList());
			result.setData(collect);
		}
		return result;
	}

	@Transactional
	public MapResponse create(RelDefModel param) {
		MapResponse response = new MapResponse();
		// TODO
		RelDef entity = RelDef.fromModel(param);
		relDefRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse update(RelDefModel param) {
		MapResponse response = new MapResponse();
		// TODO
		RelDef entity = RelDef.fromModel(param);
		relDefRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse delete(RelDefModel param) {
		MapResponse response = new MapResponse();
		// TODO
		relDefRepository.deleteById(param.getId());
		return response;
	}
}

