package com.persagy.dmp.rwd.service;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.config.DmpParameterStorage;
import com.persagy.dmp.rwd.config.RwdConstants;
import com.persagy.dmp.rwd.entity.QSchemaClass;
import com.persagy.dmp.rwd.entity.SchemaClass;
import com.persagy.dmp.rwd.model.SchemaClassModel;
import com.querydsl.core.types.dsl.BooleanExpression;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class SchemaClassService extends BaseService {

	private List<BooleanExpression> parse(ObjectNode criteria) {
		// TODO
		return null;
	}

	public PagedResponse<SchemaClassModel> query(JacksonCriteria criteria) {
		PagedResponse<SchemaClassModel> result = new PagedResponse<>();
		super.checkParam(result, RwdConstants.QUERY_GROUPCODE);
		if (!result.success()) {
			return result;
		}
		criteria.add("groupCode", DmpParameterStorage.getGroupCode());
		PagedResponse<SchemaClass> resp = criteriaUtils.query(QSchemaClass.schemaClass, this::parse, criteria);
		result.setCount(resp.getCount());
		List<SchemaClass> dataList = resp.getData();
		if (dataList != null && dataList.size() > 0) {
			List<SchemaClassModel> collect = dataList.stream().map(entity -> {
				SchemaClassModel model = entity.toModel();
				return model;
			}).collect(Collectors.toList());
			result.setData(collect);
		}
		return result;
	}

	@Transactional
	public MapResponse create(SchemaClassModel param) {
		MapResponse response = new MapResponse();
		super.checkParam(response, RwdConstants.QUERY_GROUPCODE);
		if (!response.success()) {
			return response;
		}
		// TODO
		SchemaClass entity = SchemaClass.fromModel(param);
		entity.setGroupCode(DmpParameterStorage.getGroupCode());
		schemaClassRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse update(SchemaClassModel param) {
		MapResponse response = new MapResponse();
		super.checkParam(response, RwdConstants.QUERY_GROUPCODE);
		if (!response.success()) {
			return response;
		}
		// TODO
		SchemaClass entity = SchemaClass.fromModel(param);
		schemaClassRepository.save(entity);
		response.add("id", entity.getId());
		return response;
	}

	@Transactional
	public MapResponse delete(SchemaClassModel param) {
		MapResponse response = new MapResponse();
		super.checkParam(response, RwdConstants.QUERY_GROUPCODE);
		if (!response.success()) {
			return response;
		}
		// TODO
		schemaClassRepository.deleteById(param.getId());
		return response;
	}
}

