package com.persagy.dmp.rwd.service.iot;

import com.persagy.common.criteria.JpaUtils;
import com.persagy.dmp.config.DmpParameterStorage;
import com.persagy.dmp.common.http.HttpUtils;
import com.persagy.dmp.rwd.model.iot.DataInfo;
import com.persagy.dmp.rwd.service.BaseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.Map;

@Service
public class BaseIotService extends BaseService {

	@Autowired
	protected HttpUtils httpUtils;

	@Value("${persagy.iot.data.server}")
	protected String iotDataServer;

	@Value("${persagy.iot.setting.server}")
	protected String iotSettingServer;

	@Autowired
	protected JpaUtils jpaUtils;

	protected DataInfo queryDataInfo(String groupCode, String objectId, String infoCode) {
		String projectId = DmpParameterStorage.getProjectId();
		String sql = "select class_code, json_unquote(json_extract(infos, '$." + infoCode + "')) meter from rwd_object where group_code = ? and project_id = ? and id = ?";
		Map<String, Object> result = jpaUtils.queryOne(sql, groupCode, projectId, objectId);
		if (result != null && result.size() > 0) {
			String meter = (String) result.get("meter");
			if (meter == null) {
				return null;
			}
			DataInfo info = new DataInfo();
			info.setObjectId(objectId);
			info.setClassCode((String) result.get("classCode"));
			info.setInfoCode(infoCode);
			info.setInfoCodeValue(meter);
			return info;
		} else {
			return null;
		}
	}


}
