package com.persagy.dmp.rwd.sharding;

import lombok.extern.slf4j.Slf4j;
import org.apache.shardingsphere.api.sharding.standard.PreciseShardingAlgorithm;
import org.apache.shardingsphere.api.sharding.standard.PreciseShardingValue;

import java.util.Collection;

/**
 * @author: yaoll
 * @date: 2020-10-28
 * @verison: 1.0
 */
@Slf4j
public class GroupShardingAlgorithm implements PreciseShardingAlgorithm<String> {

	@Override
	public String doSharding(Collection<String> availableTargetNames, PreciseShardingValue<String> shardingValue) {
		String logicTableName = shardingValue.getLogicTableName();
		String value = shardingValue.getValue();
		if (value == null || "0".equals(value)) {
			return logicTableName;
		} else {
			return logicTableName + "_" + value.toLowerCase();
		}
	}

}
