package com.persagy.dmp.rwd.util;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ArrayNode;
import com.fasterxml.jackson.databind.node.JsonNodeFactory;
import com.fasterxml.jackson.databind.node.JsonNodeType;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.JacksonCriteria;
import org.springframework.stereotype.Component;

/**
 * @author: yaoll
 * @date: 2020-09-22
 * @verison: 1.0
 */
@Component
public class ClassCodeUtils {
	
	public void prepareCriteriaForFuncid(JacksonCriteria criteria, String codeName) {
		ObjectNode objectNode = criteria.getCriteria();
		if (objectNode.has(codeName)) {
			JsonNode classCodeNode = objectNode.get(codeName);
			JsonNodeType nodeType = classCodeNode.getNodeType();
			if (nodeType == JsonNodeType.ARRAY) {
				ArrayNode array = JsonNodeFactory.instance.arrayNode();
				for (JsonNode jsonNode : ((ArrayNode) classCodeNode)) {
					String str = jsonNode.asText();
					if (str.indexOf("&") == -1) {
						array.add(str);
					} else {
						array.add(str.substring(str.indexOf("&")));
					}
				}
				objectNode.remove(codeName);
				objectNode.set(codeName, array);
			} else if (nodeType == JsonNodeType.OBJECT) {
				ObjectNode obj = (ObjectNode) classCodeNode;
				if (obj.has("$in")) {
					JsonNode $in = obj.get("$in");
					if ($in.getNodeType() == JsonNodeType.ARRAY) {
						ArrayNode array = JsonNodeFactory.instance.arrayNode();
						for (JsonNode jsonNode : ((ArrayNode) $in)) {
							String str = jsonNode.asText();
							if (str.indexOf("&") == -1) {
								array.add(str);
							} else {
								array.add(str.substring(str.indexOf("&")));
							}
						}
						obj.remove("$in");
						obj.set("$in", array);
					}
				}
			} else if (nodeType == JsonNodeType.STRING) {
				String code = classCodeNode.asText();
				int idx = code.indexOf("&");
				if (idx > -1) {
					criteria.add(codeName, code.substring(0, idx));
				}
			}
		}
	}


}
