package com.persagy.dmp.dpt.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.dpt.entity.TaskCfg;
import com.persagy.dmp.dpt.model.TaskRecordModel;
import com.persagy.dmp.dpt.service.TaskRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/task/record")
public class TaskRecordController {
	@Autowired
	private TaskRecordService service;
	
	@PostMapping("/query")
	public PagedResponse<TaskRecordModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
//	@PostMapping("/create")
//	public MapResponse create(@RequestBody TaskRecordModel param){
//		return service.create(param);
//	}
	
	@PostMapping("/update")
	public MapResponse update(@RequestBody TaskRecordModel param){
		return service.update(param);
	}
	
//	@PostMapping("/delete")
//	public MapResponse delete(@RequestBody TaskRecordModel param){
//		return service.delete(param);
//	}
	/**
	 * 任务调度回调接口
	 * @param taskIds
	 * @return
	 */
	@PostMapping("/receive")
	public MapResponse sendTaskToRmq(@RequestBody List<String> taskIds){
		MapResponse response = new MapResponse();
		service.saveAndSendMq(taskIds);
		return response;
	}
}
