package com.persagy.dmp.dpt.entity;

import com.fasterxml.jackson.databind.node.ObjectNode;
import lombok.Getter;
import lombok.Setter;
import com.persagy.dmp.dpt.model.TaskRecordModel;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Type;

import javax.persistence.GeneratedValue;
import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "dpt_task_record")
public class TaskRecord {

	@Id
	@GeneratedValue(generator = "assignedId")
	@GenericGenerator(name = "assignedId", strategy = "assigned")
	private String id;
	private String taskId;
	private Date startTime;
	private Date endTime;
	private Integer success;
	@Type(type = "json")
	private ObjectNode errorInfo;

	public static TaskRecord fromModel(TaskRecordModel model) {
		TaskRecord entity = new TaskRecord();
		entity.setId(model.getId());
		entity.setTaskId(model.getTaskId());
		entity.setStartTime(model.getStartTime());
		entity.setEndTime(model.getEndTime());
		entity.setSuccess(model.getSuccess());
		entity.setErrorInfo(model.getErrorInfo());
		return entity;
	}

	public TaskRecordModel toModel() {
		TaskRecordModel model = new TaskRecordModel();
		model.setId(this.id);
		model.setTaskId(this.getTaskId());
		model.setStartTime(this.getStartTime());
		model.setEndTime(this.getEndTime());
		model.setSuccess(this.getSuccess());
		model.setErrorInfo(this.getErrorInfo());
		return model;
	}

}
