package com.persagy.dmp.dpt.rmq.config;

import com.persagy.dmp.dpt.constant.TaskConstant;
import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.DirectExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.amqp.rabbit.config.SimpleRabbitListenerContainerFactory;
import org.springframework.amqp.rabbit.connection.ConnectionFactory;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.amqp.support.converter.Jackson2JsonMessageConverter;
import org.springframework.boot.autoconfigure.amqp.SimpleRabbitListenerContainerFactoryConfigurer;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class TaskRabbitConfig {

    /**
     * 格式化输入输出格式
     * @param connectionFactory
     * @return
     */
    @Bean
    public RabbitTemplate rabbitTemplate(ConnectionFactory connectionFactory) {
        RabbitTemplate rabbitTemplate = new RabbitTemplate(connectionFactory);
        rabbitTemplate.setMessageConverter(new Jackson2JsonMessageConverter());
        return rabbitTemplate;
    }
    /*
    @Bean
    public Queue TaskQueue() {
        return new Queue("TaskQueue",true);
    }

    @Bean
    DirectExchange TaskExchange() {
        return new DirectExchange("TaskExchange",true,false);
    }

    @Bean
    Binding bindingDirect() {
        return BindingBuilder.bind(TaskQueue()).to(TaskExchange()).with("TaskRouting");
    }

    @Bean("customContainerFactory")
    public SimpleRabbitListenerContainerFactory containerFactory(
            SimpleRabbitListenerContainerFactoryConfigurer configurer,
            ConnectionFactory connectionFactory) {
        SimpleRabbitListenerContainerFactory factory = new SimpleRabbitListenerContainerFactory();
        factory.setConcurrentConsumers(TaskConstant.TASK_CONSUMER_DEFAULT_CONCURRENT);
        factory.setMaxConcurrentConsumers(TaskConstant.TASK_CONSUMER_MAX_CONCURRENT);
        configurer.configure(factory, connectionFactory);
        return factory;
    }*/
}
